/*
 *	ColorMatrix 
 *      Use 4x4 matricies to process color images.
 *      http://www.sgi.com/misc/grafica/matrix/index.html
 *
 *
 *      Paul Haeberli - 1993
 *      Please note that for these operations to be correct, we really must 
 *      operate on linear brightness values. If the input image is in a 
 *      non-linear brightness space RGB colors must be transformed into a 
 *      linear space before these matrix operations are used.
 *
 */

#include "libVu0.h"

#define RLUM    (0.3086f)
#define GLUM    (0.6094f)
#define BLUM    (0.0820f)
#define M_PI    (3.14f)

#define OFFSET_R        0
#define OFFSET_G        1
#define OFFSET_B        2
#define OFFSET_A        3

void colorMatrixIdentity();
void colorMatrixVU0Apply(unsigned char *dest,unsigned char *src);

void colorMatrixScale(float rscale,float gscale,float bscale);
void colorMatrixNegative();
void colorMatrixLum();
void colorMatrixSaturate(float sat);
void colorMatrixOffset(float roffset,float goffset,float boffset);

void colorMatrixRotateX(float rs,float rc);
void colorMatrixRotateY(float rs,float rc);
void colorMatrixRotateZ(float rs,float rc);

void colorMatrixRotateShearZ(float dx,float dy);
void colorMatrixRotateHue(float rot,int lum);


