/***************************************************************
/  Unofficial LlibPlanar - Versin 0.9.1                       /
/                                                              /
/  Modificado por Ifcaro <taslokooo@gmail.com>                 /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Versin original:                                           /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#ifndef __MATH_H_
#define __MATH_H_


/*
 *  Funciones matematicas sacadas de floatlib-ps2-v2.zip
 *  descargar desde http://ps2dev.org/kb.x?T=272
 *
 *
 *
 *  constf.o
 *    -> definiciones de constantes (PI y demas)
 *  sinf.o
 *    -> sinf();  // Devuelve el Seno del angulo en radianes 
 *    -> cosf();  // Devuelve el Coseno del angulo en radianes
 *  drand.o
 *    -> drand(); // Devuelve un numero aleatorio entre 1 y 2
 *
 * // drand.o: drand.c
 * //  $(EE_CC) -O -g -c math/drand.c
 *
 *
 *
 */



#define PI   3.14159265f
#define PI_2 6.28318530f



float sinf(float);
float cosf(float);
float atan2f (float, float);

/*
 * Random double precision floating point number between 1 and 2.
 *
 * C callable:
 *	drand( &x );
 */
int drand(double *a);
float randFloat();
int randInt(int minimo,int maximo);

/*
 * Returns the square root of x.
 */

float sqrtf(float x);

/*
 * Convert range 0x00-0xFF to radians angle
 */
__inline__ float HexToRadians(unsigned char z);
float gradosaradianes(float g);
float radianesagrados(float r);
#endif

