/***************************************************************
/  Unofficial LlibPlanar - Versin 0.9.1                       /
/                                                              /
/  Modificado por Ifcaro <taslokooo@gmail.com>                 /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Versin original:                                           /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/
//
// |-- 3D Model Version 0.2 --|
// |           -- by neofar --|
//
// 
//

#ifndef __SMF_H
#define __SMF_H

#define SMF_V 0 
#define SMF_F 1 
#define SMF_N 2 
#define SMF_E 3 
#define SMF_S 4 
#define SMF_T 5 


typedef struct { float x,y,z,w;      } V3f;  // Vector 3 Float
typedef struct { unsigned int x,y,z; } V3i;  // Vector 3 Int

typedef struct
	{
    char id[4]; // SMF - Simple Model File [version]
    char content[8];
        // 0->v -> vertex array
        // 1->f -> face array
        // 2->n -> normals (faces)
        // 3->e -> normals (vertex)
        // 4->s -> normals (vertex unified)
        // 5->t -> texture coordinates (vertes + faces)
        // 6-> (unused)
        // 7-> (unused)
	unsigned int NUMVERTEX;
	unsigned int NUMFACES;
	unsigned int NUMTVERTEX;
	unsigned int NUMTVFACES;
	} SMF_Header;


typedef struct
    {
    V3f vertex[3];
    } SMF_VNormal;

typedef struct
	{
	V3f *Vertex;	       // Vertex array
	V3i *Faces;            // Faces array

    V3f *Fnormal;          // Normal Face - Flat
	SMF_VNormal *Vnormal;  // Normals Vertex (3 for each face) - Perfect Goraud
	V3f *VSnormal;         // Normals Vertes (1 for each vertex) - Goraud

	V3f *TVertex;          // Vertex UV texture
	V3i *TFaces;	       // Faces UV texture

	} SMF_Model;

#endif
