#include <llibPlanar.h>

int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;
	int alpha=0;
	int paso=0;

    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *light;
    
    setGsPacketsize(4);     // Make 4kb for the GSPACKET
    gfxInitVideo(GFX_AUTO); // Detect Pal||NTSC

    // creamos la camara, al crear una camara esta se activa por defecto
    // por lo que no necesitamos ahora coger la referencia
    ObjectCamera *cam = cameraCreateZ(-200);
    
    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/caja.3dm");
    
    // creamos una instancia para manipular el objeto
    object = ObjectCreate(modelo3DM);

    // Objeto en FLAT
    objectSetRenderMode(object, RENDER_FLAT);
    objectSetColor(object,0xFF,0xFF,0xFF);
    
    // creamos una luz en la posicion indicada
    light = lightCreate(-10,0,-10);

    // enlazamos la luz al objeto
    objectSetLight(object,0, light);

    FlushCache(0);
	
	while (1) {
		x+=0.005f;
		y+=0.012f;
		z+=0.0013f;

		if(paso==0 && alpha<=128){
			alpha++; 
		}else{
			paso=1;
		}

		if(paso==1 && alpha>0){
			alpha--; 
		}else{
			paso=0;
		}

		gfxSyncV();        // Esperamos al Retrazo
		gfxSwapBuffers();  // cambiamos el buffer de dibujado
		gfxClear();        // y limpiamos la pantalla

		// empezamos con un degradado para el fondo
		gfxDrawBoxGoraud(
		-320,-240, 0x00, 0x00, 0x80,
		320,-240, 0x00, 0x00, 0x80,
		-320, 240, 0x10, 0x10, 0x10,
		320, 240, 0x10, 0x10, 0x10);

		objectSetAlpha(object,alpha);
		objectRotate(object,x,y,z);
		objectRender(object);

		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
	}

    return 0;
    }
