#include <llibPlanar.h>

int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;


    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *l_white, *l_blue, *l_red;

    
    setGsPacketsize(4);     // Make 4kb for the GSPACKET
    gfxInitVideo(GFX_AUTO); // Detect Pal||NTSC

    // creamos la camara, al crear una camara esta se activa por defecto
    // por lo que no necesitamos ahora coger la referencia
    ObjectCamera *cam = cameraCreateZ(-150);
    
    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/toro.3dm");
    
    // creamos una instancia para manipular el objeto
    object = ObjectCreate(modelo3DM);
    objectSetRenderMode(object, RENDER_GORAUD);
    objectSetColor(object,0xFF,0xFF,0xFF);
    
    // creamos 3 luces
    // WHITE
    l_white = lightCreate(-10,0,0);
    lightSetAmbient(l_white,0.1f,0.1f,0.1f,1.0f);
    lightSetDiffuse(l_white,0.6f,0.6f,0.6f,1.0f);
    lightCreateColorRamp(l_white);

    // BLUE
    l_blue  = lightCreate( 10, -10, -10);
    lightSetAmbient(l_blue,0.0f,0.0f,0.2f,1.0f);
    lightSetDiffuse(l_blue,0.0f,0.0f,0.8f,1.0f);
    lightCreateColorRamp(l_blue);

    // RED
    l_red   = lightCreate( 10,10,0);
    lightSetAmbient(l_red,0.2f,0.0f,0.0f,1.0f);
    lightSetDiffuse(l_red,0.8f,0.0f,0.0f,1.0f);
    lightCreateColorRamp(l_red);


    // enlazamos la luz al objeto
    objectSetLight(object,0, l_white);
    objectSetLight(object,1, l_blue);
    objectSetLight(object,2, l_red);

    FlushCache(0);

	while (1) {
		x+=0.015f;
		y+=0.012f;
		z+=0.013f;

		gfxSyncV();        // Esperamos al Retrazo
		gfxSwapBuffers();  // cambiamos el buffer de dibujado
		gfxClear();        // y limpiamos la pantalla

		// empezamos con un degradado para el fondo
		gfxDrawBoxGoraud(
		-320,-240, 0x00, 0x00, 0x80,
		320,-240, 0x00, 0x00, 0x80,
		-320, 240, 0x10, 0x10, 0x10,
		320, 240, 0x10, 0x10, 0x10);

		objectRotate(object,x,y,z);
		objectRender(object);
		
		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
	}

    return 0;
    }
