#include <llibPlanar.h>

#define MAXLUCES 3
char *luces[]=
    {
    "../../resources/lights/base.light",
    "../../resources/lights/linear.light",
    "../../resources/lights/specular.light",
    "../../resources/lights/metal.light"
    };


int main(void){
    int i;
    int dx,dy;
    unsigned char ltick=-1;
    unsigned char nluz=-1;

    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;


    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *luz;

    setGsPacketsize(16);
    gfxInitVideo(GFX_AUTO);

    // creamos la camara, al crear una camara esta se activa por defecto
    // por lo que no necesitamos ahora coger la referencia
    ObjectCamera *cam = cameraCreateZ(-200);
    
    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/pelotero.3dm");
    
    // creamos una instancia para manipular el objeto
    object = ObjectCreate(modelo3DM);
    objectSetRenderMode(object, RENDER_FLAT);
    objectSetColor(object,0xFF,0xFF,0xFF);

    luz = LoadLight("../../resources/lights/metal.light");
    lightCreateColorRamp(luz);
    objectSetLight(object,0, luz);


    FlushCache(0);


    while (1) {

        // Vamos rotando las luces
        ltick++;
        if(ltick==0)
            {
            nluz++;
            if(nluz>MAXLUCES) nluz=0;

            objectSetLight(object,0, NULL);
            // lightFree(luz);
            luz = LoadLight(luces[nluz]);
            // luz = LoadLight("../lights/metal.light");

            printf("Light = %s", luces[nluz]);


            lightCreateColorRamp(luz);
            objectSetLight(object,0, luz);
            }


        x+=0.015f;
        y+=0.012f;
        z+=0.013f;

        gfxSyncV();        // Esperamos al Retrazo
        gfxSwapBuffers();  // cambiamos el buffer de dibujado
        gfxClear();        // y limpiamos la pantalla

        // empezamos con un degradado para el fondo
        gfxDrawBoxGoraud(
          -320,-240, 0x00, 0x00, 0x80,
           320,-240, 0x00, 0x00, 0x80,
          -320, 240, 0x10, 0x10, 0x10,
           320, 240, 0x10, 0x10, 0x10);

        // dibujamos el pelotero
        objectRotate(object,x,y,z);
        objectTranslate(object,50,0,0);
        objectRender(object);

        // Dibujamos la curva de color de la luz
        dx = -280;
        dy = -128;

        gfxSetColor(0xFF,0xFF,0xFF,0x80);
        gfxDrawBox(dx,-128,dx+256,-128+256);

        gfxSetAlphaBlending(1);
        gfxSetColor(0xff,0x00,0x00,0x20);
        for(i=0;i<256;i++) gfxDrawLine(dx+i,128,dx+i,128-luz->colorRed[i]);
        gfxSetColor(0x00,0xFF,0x00,0x20);
        for(i=0;i<256;i++) gfxDrawLine(dx+i,128,dx+i,128-luz->colorGreen[i]);
        gfxSetColor(0x00,0x00,0xFF,0x20);
        for(i=0;i<256;i++) gfxDrawLine(dx+i,128,dx+i,128-luz->colorBlue[i]);

        gfxSetAlphaBlending(0);
        for(i=0;i<256;i++)
            {
            gfxSetColor(luz->colorRed[i],
                        luz->colorGreen[i],
                        luz->colorBlue[i],0x80);
            gfxDrawLine(dx+i,132,dx+i,132+32);
            }
		camRender(cam);
        gfxRender();       // enviamos todo el flujo al GS
        }

    return 0;
    }
