#include <llibPlanar.h>



int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;

    Model3DM *modelo3DM;
    Object3D *o1, *o2;
    ObjectLight *light;

    setGsPacketsize(4);     // Make 4kb for the GSPACKET
    gfxInitVideo(GFX_AUTO); // Detect Pal||NTSC


    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/caja.3dm");

    // creamos la camara, al crear una camara esta se activa por defecto
    // por lo que no necesitamos ahora coger la referencia
    ObjectCamera *cam = cameraCreateZ(-200);

    // creamos una instancia para manipular el objeto
    o1 = ObjectCreate(modelo3DM);
    o2 = ObjectCreate(modelo3DM);

    // creamos una luz en la posicion indicada
    light = lightCreate(-10,0,-10);

    // enlazamos la luz al objeto
    objectSetLight(o1,0, light);
    objectSetLight(o2,0, light);



    /*
     * Tanto TRANSLATE2D como SCALE2D afectan a la matriz de transformacion
     *       y se calculan al proyectar en pantalla, por eso solo tienen 2
     *       parametros
     */
    objectTranslate2D(o1,-120,0);
    objectTranslate2D(o2,120,0);

    objectScale2D(o1,0.6f,0.6f);
    objectScale2D(o2,1.3f,1.3f);


    FlushCache(0);

	while (1) {

		x+=0.005f;
		y+=0.012f;
		z+=0.0013f;

		gfxSyncV();        // Esperamos al Retrazo
		gfxSwapBuffers();  // cambiamos el buffer de dibujado
		gfxClear();        // y limpiamos la pantalla

		// empezamos con un degradado para el fondo
		gfxDrawBoxGoraud(
		-320,-240, 0x00, 0x00, 0x80,
		320,-240, 0x00, 0x00, 0x80,
		-320, 240, 0x10, 0x10, 0x10,
		320, 240, 0x10, 0x10, 0x10);

		objectRotate(o1,x,y,z);
		objectRender(o1);

		objectRotate(o2,x,y,z);
		objectRender(o2);

		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
	}

    return 0;
    }
