#include <llibPlanar.h>


int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;

    int idImagen;
    int idTextura;

    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *luz;

    setGsPacketsize(16);
    gfxInitVideo(GFX_AUTO);

    // Inicializamos LlibTex
    texturePrepareArray(1, 1);

    // Cargamos una Imagen, y generamos una Textura de esa imagen
    // ambos metodos devuelven el indice, pero al ser un unico registro
    // sabemos que es el 0
    idImagen  = imageLoadRaw("../../resources/images/warning_128.raw", 128, 128, LIB_GS_PSMCT32);
    idTextura = textureCreate(idImagen,0,0,128,128);

    
    // creamos la camara, al crear una camara esta se activa por defecto
    // por lo que no necesitamos ahora coger la referencia
    ObjectCamera *cam = cameraCreateZ(-150);
    
    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/caja.3dm");
    
    // creamos una instancia para manipular el objeto
    object = ObjectCreate(modelo3DM);
    objectSetRenderMode(object, RENDER_FLAT);
    objectSetRenderColor(object, RENDER_TEXTURE);
    objectSetTexture(object, 0);

    objectSetColor(object,0xFF,0xFF,0xFF);
    
    // creamos la luz
    luz = lightCreate(-10,-5,-20);
    lightSetAmbient(luz,0.1f,0.1f,0.1f,1.0f);
    lightSetDiffuse(luz,0.4f,0.4f,0.4f,1.0f);

    // enlazamos la luz al objeto
    objectSetLight(object,0, luz);

    FlushCache(0);

	while (1) {
		x+=0.015f;
		y+=0.012f;
		z+=0.013f;

		gfxSyncV();        // Esperamos al Retrazo
		gfxSwapBuffers();  // cambiamos el buffer de dibujado
		gfxClear();        // y limpiamos la pantalla

		// empezamos con un degradado para el fondo
		gfxDrawBoxGoraud(
		-320,-240, 0x00, 0x00, 0x80,
		320,-240, 0x00, 0x00, 0x80,
		-320, 240, 0x10, 0x10, 0x10,
		320, 240, 0x10, 0x10, 0x10);

		objectRotate(object,x,y,z);
		objectRender(object);

		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
	}

    return 0;
    }
