/***************************************************************
/  PS2 - LlibPlanar Version beta 1                             /
/  Sample by: neofar@ofcode.com                                /
/  http://ps2dev.ofcode.com                                    /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#include <screenshot.h>
#include <llibPlanar.h>
#include "../alpha.h"


int main(void){
    int i,j;
    u_char alpha;
    
    int px=80,py=80;
    int dx=1,dy=1;

    setGsPacketsize(4);     // Make 4kb for the GSPACKET
    gfxInitVideo(GFX_AUTO); // Detect Pal||NTSC

    FlushCache(0);

    while (1) {

        gfxSyncV();        // Esperamos al Retrazo
        gfxSwapBuffers();  // cambiamos el buffer de dibujado
        gfxClear();        // y limpiamos la pantalla

        // Dibujamos algunas primitivas
        gfxDrawBoxGoraud(
          -320,-240, 0xFF, 0xFF, 0x80,
           320,-240, 0xFF, 0xFF, 0x80,
          -320, 240, 0x40, 0x20, 0x00,
           320, 240, 0x40, 0x20, 0x00);


        // dibujamos unos cuadraditos por encima
        gfxSetAlphaBlending(1);
        alpha = 0;

        for(i=-2;i<3;i++)
        for(j=-2;j<3;j++, alpha+=2)
            {
            gfxSetColor(0x00, 0x00, 0xFF, alpha);
            gfxDrawBox(-30+i*70,-30+j*70,30+i*70,30+j*70);
            }

        gfxSetAlphaBlending(0);
        gfxSetColor(0x00, 0x00, 0x00, 0x80);
        
        for(i=-2;i<3;i++)
        for(j=-2;j<3;j++, alpha+=3)
            {
            drawBoxLined(-30+i*70,-30+j*70,30+i*70,30+j*70);
            }
        
        //C' = (A - B) * C >>7 + D  GS alpha blending
        
        addALPHA_1(ALPHA_X_CI_CS, ALPHA_X_CI_CD, ALPHA_X_AV_FIX, ALPHA_X_CI_ZR, 0x80);

        // movemos el cuadrado que se mueve        
           px+=dx; 
           py+=dy;
           
           if(px > 320-61) dx*=-1;
           if(px <-320+61) dx*=-1;
           if(py > 240-61) dy*=-1;
           if(py <-240+61) dy*=-1;
           
        gfxSetAlphaBlending(1);
        gfxSetColor(0xFF, 0xFF, 0xFF, 0x00);
        gfxDrawBox(px-60,py-60,px+60,py+60);
        
        gfxRender();       // enviamos todo el flujo al GS
        

        }

    return 0;
    }


