/***************************************************************
/  PS2 - LlibPlanar Version beta 1                             /
/  Sample by: neofar@ofcode.com                                /
/  http://ps2dev.ofcode.com                                    /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#include <screenshot.h>
#include <llibPlanar.h>
#include "../alpha.h"


int main(void){
    int i,j;
    u_char alpha;
    
    float fade=0.0f;
    float fade_factor=0.01f;
    
    setGsPacketsize(4);     // Make 4kb for the GSPACKET
    gfxInitVideo(GFX_AUTO); // Detect Pal||NTSC

    FlushCache(0);
    
    //C' = (A - B) * C >>7 + D  GS alpha blending
    // addALPHA_1(ALPHA_X_CI_CD, ALPHA_X_CI_ZR, ALPHA_X_AV_AS, ALPHA_X_CI_ZR, 0x00);
    addALPHA_1(ALPHA_X_CI_CS, ALPHA_X_CI_CD, ALPHA_X_AV_FIX, ALPHA_X_CI_ZR, 0x80);


    while (1) {

        gfxSyncV();        // Esperamos al Retrazo
        gfxSwapBuffers();  // cambiamos el buffer de dibujado
        gfxClear();        // y limpiamos la pantalla

        // Dibujamos algunas primitivas
        gfxDrawBoxGoraud(
          -320,-240, 0xFF, 0xFF, 0x80,
           320,-240, 0xFF, 0xFF, 0x80,
          -320, 240, 0x40, 0x20, 0x00,
           320, 240, 0x40, 0x20, 0x00);


        // dibujamos unos cuadraditos por encima
        gfxSetAlphaBlending(1);
        alpha = 0;

        for(i=-2;i<3;i++)
        for(j=-2;j<3;j++, alpha+=2)
            {
            gfxSetColor(0x00, 0x00, 0xFF, alpha);
            gfxDrawBox(-30+i*70,-30+j*70,30+i*70,30+j*70);
            }

        gfxSetAlphaBlending(0);
        gfxSetColor(0x00, 0x00, 0x00, 0x80);
        
        for(i=-2;i<3;i++)
        for(j=-2;j<3;j++, alpha+=3)
            {
            drawBoxLined(-30+i*70,-30+j*70,30+i*70,30+j*70);
            }
        
           
           fade+=fade_factor;
           if(fade>1.0f) fade_factor*=-1.0f;
           if(fade<0.0f) fade_factor*=-1.0f;           
           
        gfxSetAlphaBlending(1);
        gfxSetColor(0x00, 0x00, 0x00, 0x80*fade);
        gfxDrawBox(-320,-240,320,240);
        
        gfxRender();       // enviamos todo el flujo al GS
        


        }

    return 0;
    }


