#include <llibPlanar.h>

char *files[]=
    {
    "Clut8RGBA32" , "../../resources/images/clut8rgba32.iif" ,
    "Clut8RGBA16" , "../../resources/images/clut8rgba16.iif" ,
    "Clut4RGBA32" , "../../resources/images/clut4rgba32.iif" ,
    "Clut4RGBA16" , "../../resources/images/clut4rgba16.iif"
    };

void WaitSync(int n)
    {
    int i;
    for(i=0;i<n;i++)
        gfxSyncV();
    }

int main(void){
    int i;
    int idImagen;
    int idTextura;

    setGsPacketsize(4);
    gfxInitVideo(GFX_AUTO);

    // Preparamos espacio para cargar una imagen
    texturePrepareArray(4, 4);
    
    // ---- Load Font ----
    idImagen = imageLoadIIF("../../resources/images/font.iif");
    idTextura = textureCreateST(idImagen,0.0f,0.0f,1.0f,1.0f);
    textSetFont(idTextura, 2, 16, 16); // imagen=0, fonts=2, charsize=(16,16)
    textSetSize(0,2.0f); textSetSize(1,2.0f);
    textSetPadding(0,8); textSetPadding(1,12);

    // Mark the Pointer in VRAM
    // now the Texture for the font will be protected, and never reused this dir
    textureFixDir();

    FlushCache(0);

    while (1) {
       textSetColor(0xFF,0xFF,0xFF);
       textSetAlpha(0x80);

        for(i=0;i<4;i++)
            {
            gfxSyncV();
            gfxSwapBuffers();
            gfxClear();
            textSetFontActive(1);
            textPrintCenter(-20, "Loading File");
            textPrintCenter(20, files[i*2]);
            gfxRender();

            WaitSync(50);
            
            // Reset VRAM Pointer to store the texture
            textureReset();
            idImagen = imageLoadIIF(files[i*2+1]);
            idTextura = textureCreateST(idImagen,0.0f,0.0f,1.0f,1.0f);
            
            gfxSyncV();
            gfxSwapBuffers();
            gfxClear();
            textSetFontActive(0); textPrintCenter(-220, files[i*2]);
            spriteReset();
            spriteSetTexture(idTextura);
            spriteSetSize(300,300);
            spriteRender();
            gfxRender();

            WaitSync(150);
            }
        
        }

    return 0;
    }


