#include <llibPlanar.h>



int main(void){
	float x = 0.0f;
	float y = 0.0f;
	float z = 0.0f;

	int idImagen;
	int idTextura;

	Model3DM *modelo3DM;
	Object3D *object;
	ObjectLight *light;

	setGsPacketsize(256);     // Make 4kb for the GSPACKET
	gfxInitVideo(GFX_AUTO); // Detect Pal||NTSC

	// Inicializamos LlibTex
	texturePrepareArray(2, 2);

	// creamos la camara
	ObjectCamera* cam = cameraCreate();
	camRotateHex(cam,0,64,0);
	camPosition(cam,70,100,80);

	// cargamos la textura
	idImagen  = imageLoadIIF("textura.iif");
	idTextura = textureCreate(idImagen,0,0,256,256);

	// leemos un modelo 3DM
	modelo3DM = LoadModel3DM("escena.3dm");

	// creamos una instancia para manipular el objeto
	object = ObjectCreate(modelo3DM);
	objectTranslate(object,0,0,0);
	objectRotateHex(object,-64,0,0);

	// Objeto en FLAT
	objectSetRenderMode(object, RENDER_FLAT);
	objectSetRenderColor(object, RENDER_TEXTURE);
	objectSetTexture(object, idTextura);
	objectSetColor(object,0xFF,0xFF,0xFF);

	// creamos una luz en la posicion indicada
	light = lightCreate(0,-50,0);
	lightSetColor(light,0.6f,0.6f,0.6f);
	lightCreateColorRamp(light);

	// enlazamos la luz al objeto
	objectSetLight(object,0, light);

	FlushCache(0);

	int frame=0;
	int paso=0;

	while (1) {
		x+=0.005f;
		y+=0.012f;
		z+=0.0013f;

		gfxSyncV();        // Esperamos al Retrazo
		gfxSwapBuffers();  // cambiamos el buffer de dibujado
		gfxClear();        // y limpiamos la pantalla

		// empezamos con un degradado para el fondo
		gfxDrawBoxGoraud(
		-320,-240, 0x00, 0x00, 0x80,
		320,-240, 0x00, 0x00, 0x80,
		-320, 240, 0x10, 0x10, 0x10,
		320, 240, 0x10, 0x10, 0x10);

		if(frame==1){
			camTurn(cam,gradosaradianes(30),0,0);
		}else if(frame<140){
			if (paso<10){
			camPosition (cam,cam->posicion[0]-1,cam->posicion[1],cam->posicion[2]);
			paso++;
			}else{
			camPosition (cam,cam->posicion[0],cam->posicion[1]-1,cam->posicion[2]);
			paso++;
			if (paso==20) paso=0;
			}
		}else if(frame<170){
			camRotate(cam,cam->rotacion[0]-gradosaradianes(1),cam->rotacion[1]+gradosaradianes(1),0);
		}else if(frame<220){
			camRotate(cam,0,cam->rotacion[1]+gradosaradianes(1),0);
			camMove(cam,0,0,1);
		}else if(frame<260){
			camMove(cam,0,0,1);
		}else{
			camRotate(cam,0,cam->rotacion[1]+gradosaradianes(1),0);
			camMove(cam,0,0,1);
		}

		frame++;

		objectRender(object);

		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
	}

	return 0;
}
