#include <llibPlanar.h>


int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;

    int idImagen;
    int idTextura1,idTextura2;

    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *luz;

    setGsPacketsize(16);
    gfxInitVideo(GFX_AUTO);

    // Inicializamos LlibTex
    texturePrepareArray(2, 2);

    // Cargamos las texturas
    idImagen   = imageLoadRaw("../../resources/images/patio_128.raw", 128, 128, LIB_GS_PSMCT32);
    imageSetFilter(idImagen,LIB_FLT_LINEAR);
    idTextura1 = textureCreateST(idImagen,0.0f,0.0f,1.0f,1.0f);

    idImagen   = imageLoadRaw("../../resources/images/patio_env_64.raw", 64, 64, LIB_GS_PSMCT32);
    imageSetFilter(idImagen,LIB_FLT_LINEAR);
    imageSetTfx(idImagen,LIB_TFX_HILIGHT);
    idTextura2 = textureCreateST(idImagen,0.0f,0.0f,1.0f,1.0f);

    // creamos la camara, al crear una camara esta se activa por defecto
    // por lo que no necesitamos ahora coger la referencia
    ObjectCamera *cam = cameraCreateZ(-150);
    
    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/toro.3dm");
    
    // creamos una instancia para manipular el objeto
    object = ObjectCreate(modelo3DM);
    objectSetRenderMode(object, RENDER_GORAUD);

    objectSetRenderColor(object, RENDER_COLOR); 
    objectSetColor(object,0xFF,0xFF,0xFF);

    objectSetRenderMap(object, RENDER_ENV); // Activamos el Environment map
    objectSetTextureMap(object,idTextura2); // Ponemos la textura
    objectSetEnvColor(object,0x80,0x80,0x80,0x00);


    
    // creamos la luz
    luz = lightCreate(-10,-5,-20);

    // enlazamos la luz al objeto
    objectSetLight(object,0, luz);

    FlushCache(0);

	while (1) {
		x+=0.015f;
		y+=0.012f;
		z+=0.013f;

		gfxSyncV();        // Esperamos al Retrazo
		gfxSwapBuffers();  // cambiamos el buffer de dibujado
		gfxClear();        // y limpiamos la pantalla

		// dibujamos un sprite de fondo
		spriteReset();
		spriteSetTexture(0);
		spriteSetSize(640,480);
		spriteRender();

		// el objeto en 3D
		objectRotate(object,x,y,z);
		objectRender(object);
		
		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
	}

    return 0;
    }
