#include <llibPlanar.h>


int main(void){
    int i,j;
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;

    int i0,i1,i2;
    int TextureStars,t1,t2;

    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *luz;
    
    float angleStars = 0.0f;

    setGsPacketsize(16);
    gfxInitVideo(GFX_AUTO);

    // Inicializamos LlibTex
    texturePrepareArray(3, 3);

    // Cargamos las texturas
    // fondo de Estrellas
    i0 = imageLoadRaw("../../resources/images/stars_128.raw", 128, 128, LIB_GS_PSMCT32);
    imageSetFilter(i0,LIB_FLT_LINEAR);
    TextureStars = textureCreateST(i0,0.0f,0.0f,1.0f,1.0f);

    // ladrillos
    i1 = imageLoadRaw("../../resources/images/brick_64.raw", 64, 64, LIB_GS_PSMCT32);
    t1 = textureCreateST(i1,0.0f,0.0f,1.0f,1.0f);
    imageSetFilter(i1,LIB_FLT_LINEAR);

    // mapa de reflejos
    i2 = imageLoadRaw("../../resources/images/envmetal_64.raw", 64, 64, LIB_GS_PSMCT32);
    t2 = textureCreateST(i2,0.0f,0.0f,1.0f,1.0f);
    imageSetFilter(i2,LIB_FLT_LINEAR);
    imageSetTfx(i2,LIB_TFX_HILIGHT);

    // creamos la camara, al crear una camara esta se activa por defecto
    // por lo que no necesitamos ahora coger la referencia
    ObjectCamera *cam = cameraCreateZ(-300);
    
    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/hex.3dm");
    
    // creamos una instancia para manipular el objeto
    object = ObjectCreate(modelo3DM);

    objectSetRenderMode(object, RENDER_FLAT);
    objectSetRenderColor(object, RENDER_TEXTURE);
    objectSetTexture(object,t1);
    objectSetColor(object,0x80,0x80,0x80);

    objectSetRenderMap(object, RENDER_ENV);
    objectSetTextureMap(object,t2);
    objectSetEnvColor(object,0x80,0x80,0x80,0x00);


    // creamos la luz
    luz = lightCreate(-10,-5,-20);
    lightSetAmbient(luz,0.1f,0.1f,0.1f,1.0f);
    lightSetDiffuse(luz,0.5f,0.5f,0.5f,1.0f);
    lightCreateColorRamp(luz);

    // enlazamos la luz al objeto
    objectSetLight(object,0, luz);


    FlushCache(0);

	while (1) {
		x+=0.015f;
		y+=0.012f;
		z+=0.013f;

		gfxSyncV();        // Esperamos al Retrazo
		gfxSwapBuffers();  // cambiamos el buffer de dibujado
		gfxClear();        // y limpiamos la pantalla


		angleStars+=0.003f;

		// Dibujamos el fondo de estrellitas
		for(i=-1;i<=1;i++)
		for(j=-1;j<=1;j++)
		{
			spriteReset();
			spriteSetTexture(TextureStars);
			spriteSetSize(300,300);
			spriteTranslate(i*300,j*300);
			spriteRotate(angleStars);
			spriteRender();
		}

		// Dibujamos los objetos en 3D
		objectRotate(object,0,0,z);
		objectRotateHex(object,64,0,0);
		objectTranslate(object,-40,0,0);
		objectRotate(object,x,y,z);
		objectRender(object);

		objectRotate(object,0,0,z);
		objectTranslate(object,40,0,0);
		objectRotate(object,x,y,z);
		objectRender(object);

		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
	}

    return 0;
    }
