

#include <llibPlanar.h>
#include <math.h>


#define POINTS 10

int main(void){
    int i;
    float anglez = 0.0f;

    setGsPacketsize(4);
    gfxInitVideo(GFX_AUTO);

    // 1 - Make a Star Geometry
    //
    libVu0FVector *nodes;
    nodes = (libVu0FVector *)malloc(sizeof(libVu0FVector)*POINTS);
    
    for(i=0;i<POINTS;i++)
        {
        float angulo = (360.0f / POINTS) * i;
        float angle  = angulo * 3.1416f / 180.0f;

        int radius = 80.0f;
        if(i%2) radius = 120.0f;
        
        nodes[i][0] = sinf(angle) * radius;
        nodes[i][1] = cosf(angle) * radius;
        nodes[i][2] = 0.0f; // Z
        nodes[i][3] = 1.0f; // W
        }
        
    // 2 - Make Geometry structure
    //
    geometryCreate(nodes, POINTS);

    while (1) {
        gfxSyncV();
        gfxSwapBuffers();
        gfxClear();

        // dibujamos un fondo degradado
        gfxDrawBoxGoraud(
          -320,-240, 0x00, 0x00, 0x80,
           320,-240, 0x00, 0x00, 0x80,
          -320, 240, 0x40, 0x40, 0x20,
           320, 240, 0x40, 0x40, 0x20);
        
        anglez +=0.01f;

        geometryIdentity();               // <-- Make matrix identity
        geometryRotate(0.0f,0.0f,anglez); // <-- Rotate only in Z
        geometryMatrixVU0Apply();         // <-- Apply transformation to all nodes

        gfxSetColor(0xFF,0xFF,0x00,0x80); // <- Put Color
        geometryDrawPolygon(1);           // <- DrawPolygon(Filled)

        gfxRender();
        }

    return 0;
    }

