#include <screenshot.h>
#include <llibPlanar.h>
#include <math.h>
#include "../alpha.h"

#define PARTICLES (13*13)
typedef struct
    {
    int px,py;
    int status;

    unsigned char tick;
    int dir;

    } strParticle __attribute__((aligned(64)));
    
strParticle part[PARTICLES];

int tickZ=0;
float angelWorlZ = 0.0f;
float newZ = 0.0f;

void createParticles();
void stepParticles();
void drawParticles();


int main(void){

    setGsPacketsize(4);
    gfxInitVideo(GFX_AUTO);


    // Create Geometry and particles
    createParticles();

    while (1) {
        gfxSyncV();
        gfxSwapBuffers();
        gfxClear();

        // Dibujamos algunas primitivas
        gfxDrawBoxGoraud(
          -320,-256, 0xFF, 0xFF, 0x80,
           320,-256, 0xFF, 0xFF, 0x80,
          -320, 256, 0x40, 0x20, 0x00,
           320, 256, 0x40, 0x20, 0x00);


        // Step and draw
        stepParticles();
        drawParticles();

        gfxRender();
        }

    return 0;
    }


void createParticles()
    {
    int i,j;
    int id;

    // Create Hexagon geometry
    libVu0FVector *nodes;
    nodes = (libVu0FVector *)malloc(sizeof(libVu0FVector)*6);
    for(i=0;i<6;i++)
        {
        float angulo = (360.0f / 6) * i;
        float angle  = angulo * 3.1416f / 180.0f;

        nodes[i][0] = cosf(angle) * 60.0f;
        nodes[i][1] = sinf(angle) * 60.0f;
        nodes[i][2] = 0.0f; // Z
        nodes[i][3] = 1.0f; // W
        }
    geometryCreate(nodes, 6);
    // ---


    for(id=0,i=-6;i<=6;i++)
    for(j=-6;j<=6;j++,id++)
        {
        part[id].px     = i*200 + ((j%2)*100);
        part[id].py     = j*60;
        part[id].status = 0;
        part[id].tick   = 0;
        part[id].dir    = 0;
        }
    }
    
void stepParticles()
    {
    int i;
    
    // contamos las particulas que se mueven
    int particleAction = 0;

    // primero... las particulas que esten activadas rotan
    for(i=0;i<PARTICLES;i++)
    if(part[i].status == 1)
        {
        particleAction++;

        part[i].tick++;
        if(part[i].tick>=128)
            part[i].status = 0;
        }
    
    if(particleAction<=48)
    for(i=0;i<8;i++)
        {
        int id = randInt(0,PARTICLES);
        if(part[id].status == 0)
            {
            part[id].status =1;
            part[id].tick = 0;
            part[id].dir  = i%2;
            }

        }

    // Movimiento del mundo en Z

    if (tickZ++%250==0)
        {
        newZ = randInt(1,6) * (3.1416f / 2.0f);
        }

    float diferencia = newZ - angelWorlZ;
    angelWorlZ += diferencia * 0.02f;



    }
    
void drawParticles()
    {
    int i;

    for(i=0;i<PARTICLES;i++)
        {
        geometryIdentity();
        if(part[i].dir==0)
             geometryRotateHex(0.0f,part[i].tick,0.0f);
        else geometryRotateHex(part[i].tick,0.0f,0.0f);
        geometryTranslate(part[i].px,part[i].py,0);

        geometryRotate(0.0f,0.0f,angelWorlZ);
        geometryMatrixVU0Apply();

        gfxSetAlphaBlending(1);
        gfxSetColor(0xFF, 0xFF, 0xFF, 0x10);
        geometryDrawPolygon(1);

        gfxSetAlphaBlending(0);
        gfxSetColor(0x00, 0x00, 0x00, 0x20);
        geometryDrawPolygon(0);
        }
    }
    

