

#include <llibPlanar.h>
#include <math.h>

#define POINTS 11

int main(void){
    int i,j,z,x;
    float anglez = 0.0f;

    setGsPacketsize(4);
    gfxInitVideo(GFX_AUTO);

    // 1 - save space for nodes
    //
    libVu0FVector *nodes;
    nodes = (libVu0FVector *)malloc(sizeof(libVu0FVector)*POINTS);

    // 2 - Make Geometry structure
    //
    geometryCreate(nodes, POINTS);

        

    while (1) {
        gfxSyncV();
        gfxSwapBuffers();
        gfxClear();

        // dibujamos un fondo degradado
        gfxDrawBoxGoraud(
          -320,-240, 0x00, 0x00, 0x80,
           320,-240, 0x00, 0x00, 0x80,
          -320, 240, 0x40, 0x40, 0x20,
           320, 240, 0x40, 0x40, 0x20);
        
        anglez +=0.01f;

        z = 3;
        for(j=0;j<3;j++)
        for(i=0;i<3;i++,z++)
           {
           // now set the node
               for(x=0;x<z;x++)
               {
               float angulo = (360.0f / z) * x;
               float angle  = angulo * 3.1416f / 180.0f;

               nodes[x][0] = sinf(angle) * 40.0f;
               nodes[x][1] = cosf(angle) * 40.0f;
               nodes[x][2] = 0.0f; // Z
               nodes[x][3] = 1.0f; // W
               }
           //
           geometrySetSize(z);

           geometryIdentity();
           geometryRotate(0.0f,0.0f,anglez+z);
           geometryTranslate2D((i-1)*120,(j-1)*100);
           geometryMatrixVU0Apply();

           // shadow
           gfxSetAlphaBlending(1);
           geometryTranslate2D(10,10);
           gfxSetColor(0,0,0,0x30);
           geometryDrawPolygon(1);

           // Solid
           geometryTranslate2D(-10,-10);
           gfxSetColor(0xFF-i*48,
                       0xFF-j*48,
                       0x00+i*48+j*48,0x80);
           geometryDrawPolygon(1);

           // Border
           gfxSetColor(0x00,0x00,0x00,0x80);
           geometryDrawPolygon(0);
           }

        gfxRender();
        }

    return 0;
    }

