
#include <llibPlanar.h>
#include <math.h>


ObjectCamera *camara3D;
Model3DM *modelBox;
Object3D *objectBox;
ObjectLight *luz;


int main(void){
    int idImagen;
    int idTextura;

    int frame;
    int tick=0;
    float x=0.0f,y=0.0f,z=0.0f;

    setGsPacketsize(4);
    gfxInitVideo(GFX_AUTO);

    // Inicializamos LlibTex
    texturePrepareArray(16, 16);

    // idImagen  = imageLoadIIF("explosion2.iif");
    idImagen  = imageLoadIIF("../../resources/images/sonic.iif"); // GIF ANIMADO !!!!
    idTextura = textureCreateST(idImagen,0.0f,0.0f,1.0f,1.0f);

    // Creamos la camara
    camara3D    = cameraCreateZ(-150);

    // creamos una luz
    luz = lightCreate(10,2,-20);

    modelBox = LoadModel3DM("../../resources/models/box.3dm");
    objectBox = ObjectCreate(modelBox);
    objectSetRenderMode(objectBox, RENDER_FLAT);
    objectSetRenderColor(objectBox, RENDER_TEXTURE);
    objectSetColor(objectBox,0xFF,0xFF,0xFF);
    objectSetTexture(objectBox,idTextura);
    objectSetLight(objectBox, 0, luz);


    FlushCache(0);

    frame = 0;
            
    while (1) {
        x+=0.01f;
        y+=0.011f;
        z+=0.03f;

        gfxSyncV();        // Esperamos al Retrazo
        gfxSwapBuffers();  // cambiamos el buffer de dibujado
        gfxClear();        // y limpiamos la pantalla

        gfxDrawBoxGoraud( -320,-240, 0x00, 0x00, 0x80,
                           320,-240, 0x00, 0x00, 0x80,
                          -320, 240, 0x05, 0x05, 0x00,
                           320, 240, 0x05, 0x05, 0x00);


        tick++;

        if(tick%5==0) frame++;
        imageSetFrame(idImagen,frame); // <-- Set Frame for all objects that use this image

        objectRotate(objectBox,x,y,z);
        objectTranslate2D(objectBox,0,0);
        objectRender(objectBox);

		camRender(camara3D);
        gfxRender();       // enviamos todo el flujo al GS
        }

    return 0;
    }


