#include <llibPlanar.h>




int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;

    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *luz;

    // inicializa el modo grafico
    setGsPacketsize(16);
    gfxInitVideo(GFX_AUTO);


    // Preparamos el BufferZ para dibujar en 2 capas
    layerZInit(3);
    //
    // 0x0000..........................................................0xFFFF
    // |         |                                                 |         |
    // | LAYER 0 |                  LAYER 1                        | LAYER 2 |
    // |         |                                                 |         |
    // 0        256                                        (65536-256)     65536

    layerZStartAt(0,0x0000);
    layerZStartAt(1,0x00FF);
    layerZStartAt(2,0xFFFF - 0x00FF);

    // Creamos una camara para renderizar en el Layer 1
    ObjectCamera *cam = cameraCreateForLayer(-200,1);
    
    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/caja.3dm");
    object = ObjectCreate(modelo3DM);
    objectSetRenderColor(object, RENDER_COLOR);
    objectSetRenderMode(object, RENDER_FLAT);
    objectSetColor(object,0xFF,0xFF,0xFF);


    // creamos la luz
    luz = lightCreate(-10,-5,-20);

    // enlazamos la luz al objeto
    objectSetLight(object,0, luz);

    FlushCache(0);

    while (1) {
       x+=0.015f;
       y+=0.012f;
       z+=0.013f;

        gfxSyncV();        // Esperamos al Retrazo
        gfxSwapBuffers();  // cambiamos el buffer de dibujado
        gfxClear();        // y limpiamos la pantalla


        //
        // LAYER 0
        //
        layerZActive(0);
            gfxSetAlphaBlending(1);
            gfxSetColor(0x00,0x00,0xFF,0x20);
            gfxDrawBox(-300,-100,0,100);

        //
        // LAYER 1
        //
        layerZActive(1);
            objectRotate(object,x,y,z);
            objectRender(object);

        //
        // LAYER 2
        //
        layerZActive(2);
            gfxSetAlphaBlending(1);
            gfxSetColor(0xFF,0x00,0x00,0x20);
            gfxDrawBox(0,-100,300,100);

		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
	}

    return 0;
    }
