#include <llibPlanar.h>


int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;

    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *luz;

    // Vamos a tener 2 Camaras
    ObjectCamera *CameraLayer1;
    ObjectCamera *CameraLayer3;

    // inicializa el modo grafico
    setGsPacketsize(16);
    gfxInitVideo(GFX_AUTO);

    //
    // 0x0000..........................................................0xFFFF
    // |         |                 |         |                     |         |
    // | LAYER 0 |     LAYER 1     | LAYER 2 |       LAYER 3       | LAYER4  |
    // |         |                 |         |                     |         |
    // 0        FFF              7FFF-FF   7FFF+FF                FFFF-FF   FFFF
    //
    layerZInit(5);

    layerZStartAt(0,0x0000);
    layerZStartAt(1,0x00FF);        // <-- aqui crearemos una camara 3D
    layerZStartAt(2,0x7FFF - 0xFF);
    layerZStartAt(3,0x7FFF + 0xFF); // <-- aqui la otra camara 3D
    layerZStartAt(4,0xFFFF - 0xFF);

    // Preparamos 2 camaras, cada una de ellas va a renderizar los objetos
    // para encajarlos en la capa seleccionada
    CameraLayer1 = cameraCreateForLayer(-200,1);
    CameraLayer3 = cameraCreateForLayer(-200,3);

    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/caja.3dm");
    object = ObjectCreate(modelo3DM);
    objectSetRenderColor(object, RENDER_COLOR);
    objectSetRenderMode(object, RENDER_FLAT);
    objectSetColor(object,0xFF,0xFF,0xFF);


    // creamos la luz
    luz = lightCreate(-10,-5,-20);

    // enlazamos la luz al objeto
    objectSetLight(object,0, luz);

    FlushCache(0);

    while (1) {
       x+=0.015f;
       y+=0.012f;
       z+=0.013f;

        gfxSyncV();        // Esperamos al Retrazo
        gfxSwapBuffers();  // cambiamos el buffer de dibujado
        gfxClear();        // y limpiamos la pantalla

        gfxSetAlphaBlending(0);

        //
        // LAYER 0
        //
        layerZActive(0);
            gfxSetColor(0xFF,0x00,0x00,0x80);
            gfxDrawBox(-320,-240,0,0);

        //
        // LAYER 1
        //
        layerZActive(1);
            cameraSetActive(CameraLayer1); // <- Activamos la camara
            objectRotate(object,x,y,z);
            objectTranslate(object,-20,20,0);
            objectRender(object);
			camRender(CameraLayer1);

        //
        // LAYER 2
        //
        layerZActive(2);
            gfxSetColor(0x00,0xFF,0x00,0x80);
            gfxDrawBox(-160,-120,160,120);

        //
        // LAYER 3
        //
        layerZActive(3);
            cameraSetActive(CameraLayer3); // <- Activamos la camara
            objectRotate(object,x,y,z);
            objectTranslate(object,20,-20,0);
            objectRender(object);
			camRender(CameraLayer3);
        //
        // LAYER 4
        //
        layerZActive(4);
            gfxSetColor(0x00,0x00,0xFF,0x80);
            gfxDrawBox(0,0,320,240);

       gfxRender();       // enviamos todo el flujo al GS

    }

    return 0;
    }
