#include <llibPlanar.h>





int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;

    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *luz;

    // Vamos a tener 2 Camaras
    ObjectCamera *CameraLayer0;
    ObjectCamera *CameraLayer1;

    // inicializa el modo grafico
    setGsPacketsize(16);
    gfxInitVideo(GFX_AUTO);

    //
    // 0x0000..........................................................0xFFFF
    // |         |                                                         |
    // | LAYER 0 |                                                 LAYER 1 |
    // |         |                                                         |
    // 0        16                                                       FFFF
    //
    layerZInit(2);

    layerZStartAt(0,0);
    layerZStartAt(1,16);

    // La capa 0 tiene un rango 0-16 MUY POCO para que el BufferZ pueda
    // calcular correctamente el orden de los poligonos... lo calcula.. per
    // en ese rango tan pequeo muchos poligosno caern a la misma altura
    //
    // En este sample renderizamos 2 objetos, uno en cada layer, se ve como
    // el objeto que se renderiza en el layer 0 no se visualiza correctamente


    // Preparamos 2 camaras, cada una de ellas va a renderizar los objetos
    // para encajarlos en la capa seleccionada
    CameraLayer0 = cameraCreateForLayer(-250,0);
    CameraLayer1 = cameraCreateForLayer(-250,1);

    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/caja.3dm");
    object = ObjectCreate(modelo3DM);
    objectSetRenderColor(object, RENDER_COLOR);
    objectSetRenderMode(object, RENDER_FLAT);
    objectSetColor(object,0xFF,0xFF,0xFF);


    // creamos la luz
    luz = lightCreate(-10,-5,-20);

    // enlazamos la luz al objeto
    objectSetLight(object,0, luz);

    FlushCache(0);

    while (1) {
       x+=0.015f;
       y+=0.012f;
       z+=0.013f;

        gfxSyncV();        // Esperamos al Retrazo
        gfxSwapBuffers();  // cambiamos el buffer de dibujado
        gfxClear();        // y limpiamos la pantalla

        gfxSetAlphaBlending(0);

        //
        // LAYER 0
        //
        layerZActive(0);
            cameraSetActive(CameraLayer0); // <- Activamos la camara
            objectRotate(object,x,y,z);
            objectTranslate(object,-60,0,0);
            objectRender(object);
			camRender(CameraLayer0);
        //
        // LAYER 1
        //
        layerZActive(1);
            cameraSetActive(CameraLayer1); // <- Activamos la camara
            objectRotate(object,x,y,z);
            objectTranslate(object,60,0,0);
            objectRender(object);
			camRender(CameraLayer1);

       gfxRender();       // enviamos todo el flujo al GS
    }

    return 0;
    }
