#include <llibPlanar.h>


int main(void){
    int idImagen;
    int idTextura;
    float angle=0.0f;

    setGsPacketsize(4);
    gfxInitVideo(GFX_AUTO);

    // Preparamos espacio para cargar una imagen
    texturePrepareArray(2, 2);

    // firts Load Clut Image
    idImagen  = imageLoadIIF("../../resources/images/clut8rgba32.iif");
    idTextura = textureCreateST(idImagen,0.0f,0.0f,1.0f,1.0f);

    FlushCache(0);


    // Get Pointer to CLUT DATA
    unsigned char *pal = imageGetClut(idImagen);
    unsigned char *palOrigen;

    // Make a copy for save the original pal
    palOrigen = (unsigned char *)malloc(256*4);
    memcpy(palOrigen,pal,256*4);


    // Pal is pointer to the Data Clut
    // PalOrigen is a copy of the colors
    //
    // So now, whe can make transforms with the PalOrigen and
    // store the result in pal for apply at the image


    while (1) {

        angle += 0.01f;
        float GrayScale = (sinf(angle)*0.5f)+0.5f;

        gfxSyncV();
        gfxSwapBuffers();
        gfxClear();

        // Image in negate
        colorMatrixIdentity();    // Make matrix identity
        colorMatrixSaturate(GrayScale); 
        colorMatrixVU0Apply(pal,palOrigen); // and aply
        // End matrix operations

        imageUpdateClut(idImagen); // Resend clut to EE

        // And Draw Image
        spriteReset();
        spriteSetTexture(idTextura);
        spriteSetSize(400,400);
        spriteRender();

        // Draw Channels Bars
        // Red
        gfxSetColor(0xFF,0xFF,0xFF,0x80);
        gfxDrawBox(-200,210,-200+(GrayScale*400.0f),220);


        gfxRender();       // enviamos todo el flujo al GS
        }

    return 0;
    }


