#include <llibPlanar.h>


int main(void){
    int idImagen;
    int idTextura;
    float angler=0.0f;
    float angleg=0.0f;
    float angleb=0.0f;


    setGsPacketsize(4);
    gfxInitVideo(GFX_AUTO);

    // Preparamos espacio para cargar una imagen
    texturePrepareArray(2, 2);

    // firts Load Clut Image
    idImagen  = imageLoadIIF("../../resources/images/clut8rgba32.iif");
    idTextura = textureCreateST(idImagen,0.0f,0.0f,1.0f,1.0f);

    FlushCache(0);


    // Get Pointer to CLUT DATA
    unsigned char *pal = imageGetClut(idImagen);
    unsigned char *palOrigen;

    // Make a copy for save the original pal
    palOrigen = (unsigned char *)malloc(256*4);
    memcpy(palOrigen,pal,256*4);


    // Pal is pointer to the Data Clut
    // PalOrigen is a copy of the colors
    //
    // So now, whe can make transforms with the PalOrigen and
    // store the result in pal for apply at the image


    while (1) {

        angler += 0.01f;
        angleg += 0.02f;
        angleb += 0.03f;

        float scaler = sinf(angler)*0.5f+0.5f;
        float scaleg = sinf(angleg)*0.5f+0.5f;
        float scaleb = sinf(angleb)*0.5f+0.5f;

        gfxSyncV();
        gfxSwapBuffers();
        gfxClear();

        // Image in negate
        colorMatrixIdentity();    // Make matrix identity
        colorMatrixScale(scaler,scaleg,scaleb); // Scale each channel
        colorMatrixVU0Apply(pal,palOrigen); // and aply
        // End matrix operations

        imageUpdateClut(idImagen); // Resend clut to EE

        // And Draw Image
        spriteReset();
        spriteSetTexture(idTextura);
        spriteSetSize(400,400);
        spriteRender();

        // Draw Channels Bars
        // Red
        gfxSetColor(0xFF,0,0,0x80);
        gfxDrawBox(-200,210,-200+(scaler*400.0f),214);
        // Green
        gfxSetColor(0,0xFF,0,0x80);
        gfxDrawBox(-200,214,-200+(scaleg*400.0f),218);
        // Blue
        gfxSetColor(0,0,0xFF,0x80);
        gfxDrawBox(-200,218,-200+(scaleb*400.0f),222);


        gfxRender();       // enviamos todo el flujo al GS
        }

    return 0;
    }


