#include <llibPlanar.h>


int main(void){
    int idImagen;
    int idTextura;

    setGsPacketsize(4);
    gfxInitVideo(GFX_AUTO);

    // Preparamos espacio para cargar una imagen
    texturePrepareArray(2, 2);

    // firts Load Clut Image
    idImagen  = imageLoadIIF("clut.iif");
    idTextura = textureCreateST(idImagen,0.0f,0.0f,1.0f,1.0f);

    FlushCache(0);


    // Get Pointer to CLUT DATA
    unsigned char *pal = imageGetClut(idImagen);
    unsigned char *palOrigen;

    // Make a copy for save the original pal
    palOrigen = (unsigned char *)malloc(256*4);
    memcpy(palOrigen,pal,256*4);


    // Pal is pointer to the Data Clut
    // PalOrigen is a copy of the colors
    //
    // So now, whe can make transforms with the PalOrigen and
    // store the result in pal for apply at the image


    while (1) {

        gfxSyncV();
        gfxSwapBuffers();
        gfxClear();

        // And Draw Image
        spriteReset();
        spriteSetTexture(idTextura);
        spriteSetSize(128,128);
        spriteTranslate(-200,-200+64);
        spriteRenderPal();

        spriteReset();
        spriteSetTexture(idTextura);
        spriteSetSize(400,400);
        spriteTranslate(100,0);
        spriteRender();

        gfxRender();       // enviamos todo el flujo al GS
        }

    return 0;
    }


