#include <llibPlanar.h>


int main(void){
    float x = 0.0f;
    float y = 0.0f;
    float z = 0.0f;

    Model3DM *modelo3DM;
    Object3D *object;
    ObjectLight *light;
    
    setGsPacketsize(16);
    gfxInitVideo(GFX_AUTO);

    // creamos la camara, al crear una camara esta se activa por defecto
    // por lo que no necesitamos ahora coger la referencia
    ObjectCamera* cam=cameraCreateZ(-150);
    
    // leemos un modelo 3DM
    modelo3DM = LoadModel3DM("../../resources/models/toro.3dm");
    
    // creamos una instancia para manipular el objeto
    object = ObjectCreate(modelo3DM);

    objectSetColor(object,0xFF,0xFF,0xFF);
    
    // creamos una luz en la posicion indicada
    light = lightCreate(-10,-10,-10);

    // enlazamos la luz al objeto
    objectSetLight(object,0, light);

    FlushCache(0);

    while (1) {
		x+=0.015f;
		y+=0.012f;
		z+=0.013f;

		gfxSyncV();        // Esperamos al Retrazo
		gfxSwapBuffers();  // cambiamos el buffer de dibujado
		gfxClear();        // y limpiamos la pantalla

		// empezamos con un degradado para el fondo
		gfxDrawBoxGoraud(
		-320,-240, 0x00, 0x00, 0x80,
		320,-240, 0x00, 0x00, 0x80,
		-320, 240, 0x10, 0x10, 0x10,
		320, 240, 0x10, 0x10, 0x10);

		// 
		// POINT
		//
		gfxSetScissor(-320,-240,0,0);
		objectSetRenderMode(object, RENDER_POINT);
		objectRotate(object,x,y,z);
		objectRender(object);

		//
		// WIREFRAME
		// 
		gfxSetScissor(0,-240,320,0);
		objectSetRenderMode(object, RENDER_WIREFRAME);
		objectRotate(object,x,y,z);
		objectRender(object);

		//
		// FLAT
		// 
		gfxSetScissor(-320,0,0,240);
		objectSetRenderMode(object, RENDER_FLAT);
		objectRotate(object,x,y,z);
		objectRender(object);

		//
		// GORAUD
		// 
		gfxSetScissor(0,0,320,240);
		objectSetRenderMode(object, RENDER_GORAUD);
		objectRotate(object,x,y,z);
		objectRender(object);

		camRender(cam);
		gfxRender();       // enviamos todo el flujo al GS
    }

    return 0;
    }
