
#include <llibPlanar.h>
#include "math.h"

void drawConsole();


int main(void){

    setGsPacketsize(4);     // Make 4kb for the GSPACKET
    gfxInitVideo(GFX_AUTO); // Detect Pal||NTSC

    // Inicializamos LlibTex
    texturePrepareArray(1, 1);
    
    // Cargamos una Imagen, y generamos una Textura de esa imagen
    imageLoadRaw("../../resources/images/Font_256.raw", 256, 256, LIB_GS_PSMCT32);
    textureCreate(0,0,0,256,256);

    FlushCache(0);

    // Activamos la fuente
    textSetFont(0, 2, 16, 16); // imagen=0, fonts=2, charsize=(16,16)
    textSetSize(0,1.6f); // fuente[0] -> size 2
    textSetSize(1,2.0f); // fuente[1] -> size 2
    textSetPadding(0,9); // fuente[0] -> padding 8 pixels
    textSetPadding(1,12);// fuente[1] -> padding 12 pixels


    // Setup Console
    consoleCreate();
    consoleSet(-200,-100,400,200,0);   // x,y,w,h, font
    consoleSetColor(0xFF,0xFF,0xFF);  // Color for Text
    consoleSetAlpha(0xFF);            // Alpha

    consolePrintf("LLibPlanar 2.0 \n");
    consolePrintf("By neofar \n\n");

    // Artist: Lu
    // Song Title: Una Confusion
    consolePrintf("fui solo una confusion\n");
    consolePrintf("y que soy yo tu gran error\n");
    consolePrintf("olvido de un viejo amor\n");
    consolePrintf("una confusion\n");
    consolePrintf("que actuaste sin pensar\n");
    consolePrintf("que yo de ti me enamoraria y tal vez\n");
    consolePrintf("tu podrias arruinar mi vida\n");
    consolePrintf("tu...\n");
    consolePrintf("\n");
    consolePrintf("No quiero que me digas nada\n");
    consolePrintf("no quiero que me vuelvas a hablar\n");
    consolePrintf("arma suicida del alma\n");
    consolePrintf("que destruyes mi fe de amar\n");
    consolePrintf("\n");
    consolePrintf("un huracan que mata\n");
    consolePrintf("despacio y me desangra\n");
    consolePrintf("tan fuerte que hoy acaba mi paciencia ante ti\n");
    consolePrintf("mis ganas de vivir y me rindo a este sufrir\n");
    consolePrintf("no me busques que yo a ti te detesto\n");
    consolePrintf("y solo encuentro que yo de ti fui...\n");

    /*
    consoleClear();

    // consoleSetColorId(int id, int r,int g,int b,int a);

    consoleSetColorId(0, 0xFF,0xFF,0xFF,0xFF);
    consoleSetColorId(1, 0xff,0x00,0x00,0xFF);
    consoleSetColorId(2, 0x00,0xff,0x00,0xFF);
    consoleSetColorId(3, 0x00,0x00,0xFF,0xFF);
    consoleSetColorId(4, 0xff,0xFF,0x00,0xFF);

    consolePrintf("\\1El tuyo es rojo relativo,");
    consolePrintf("\\2no se mancha de amor y por eso ");
    consolePrintf("\\3canta muy dentro de ti,");
    consolePrintf("\\4por tu gran soledad y porque...");
    consolePrintf("\\0Venga... mate mucho esta noche ");
    consolePrintf("y maana vuelve a ser quien ");
    consolePrintf("no se divierte porque ");
    consolePrintf("buscas algo ms fcil de hacer.");
*/
    // consoleRenderHost();


    while (1) {
       gfxSyncV();        // Esperamos al Retrazo
       gfxSwapBuffers();  // cambiamos el buffer de dibujado
       gfxClear();        // y limpiamos la pantalla


       drawConsole();

        
       gfxRender();       // enviamos todo el flujo al GS
       }

    return 0;
    }

void drawConsole()
    {
    static float angle =0.0f;

    int x1 = -200;
    int y1 = -100;
    int x2 =  200;
    int y2 =  100;

    angle+=0.008f;
    float factor = cosf(angle)*0.5f-0.5f;

    gfxSetAlphaBlending(1);

    // BackGround
    gfxSetColor(0x80,0x20,0x00,0x30);
    gfxDrawBox(x1,y1,x2,y2);
    gfxDrawBox(x2+12,y1,x2+12+16,y2);

    // Border para la consola
    gfxSetColor(0x80,0x80,0x80,0xFF);
    drawBoxLined2(x1-2,y1-2,x2+2,y2+2,2);

    // ScrollBar
    drawBoxLined2(x2+12,y1-2,x2+12+16,y2+2,2);
    gfxSetColor(0x80,0x80,0x80,0x80);
    gfxDrawBox(x2+12,y1-(factor*180.0f),x2+12+16,y1-(factor*180.0f)+20);

    // And render console
    consoleSetView(factor);
    consoleRender();
    }

