#include <llibPlanar.h>
#include "math.h"

int main(void){
    int px=80,py=80;
    int dx=1,dy=1;
    int sizex, sizey ;

    setGsPacketsize(4);     // Make 4kb for the GSPACKET
    gfxInitVideo(GFX_AUTO); // Detect Pal||NTSC

    // Inicializamos LlibTex
    texturePrepareArray(1, 1);
    
    // Cargamos una Imagen, y generamos una Textura de esa imagen
    imageLoadRaw("../../resources/images/Font_256.raw", 256, 256, LIB_GS_PSMCT32);
    textureCreate(0,0,0,256,256);

    // Activamos la fuente
    textSetFont(0, 2, 16, 16); // imagen=0, fonts=2, charsize=(16,16)
    textSetSize(0,2.0f); // fuente[0] -> size 2
    textSetSize(1,2.0f); // fuente[1] -> size 2
    textSetPadding(1,8);  // fuente[0] -> padding 8

    FlushCache(0);

    while (1) {
       gfxSyncV();        // Esperamos al Retrazo
       gfxSwapBuffers();  // cambiamos el buffer de dibujado
       gfxClear();        // y limpiamos la pantalla

       // empezamos con un degradado para el fondo
       gfxDrawBoxGoraud(
          -320,-240, 0x20, 0x00, 0x80,
           320,-240, 0x00, 0x00, 0x80,
          -320, 240, 0x20, 0x80, 0x00,
           320, 240, 0x00, 0x80, 0x00);

       // movemos el cuadrado del fondo
           px+=dx;  py+=dy;
           if(px > 320-61) dx*=-1;
           if(px <-320+61) dx*=-1;
           if(py > 240-61) dy*=-1;
           if(py <-240+61) dy*=-1;

       // y lo dibujamos de fondo
       gfxSetColor(0x20, 0x40, 0x60, 0x80);
       gfxDrawBox(px-60,py-60,px+60,py+60);
       gfxSetColor(0xFF, 0xFF, 0xFF, 0x80);
       drawBoxLined(px-60,py-60,px+60,py+60);


       // medimos cuanto ocupa el texto que queremos enviar
       textSetFontActive(0); 
       sizey = textGetHeight();
       sizex = textGetWidth("-- Llib Planar --");

       sizey = sizey * 2 + 16; // y * 2Lineas + 16, para tener un margen
       sizex = sizex + 16;     //  

       // Bordeamos con una linea el texto
       gfxSetColor(GS_CYAN,0x80);
       drawBoxLined(-sizex/2,-sizey/2,sizex/2,sizey/2);

       // Pongo blanco sin transparencia
       textSetColor(GS_WHITE);
       textSetAlpha(0x80);

       // y envio 2 textos, uno con cada fuente
       textSetFontActive(0); textPrintCenter(-34, "-- Llib Planar --");
       textSetFontActive(1); textPrintCenter(  2, "Version 2.0");

       // ahora medimos el otro texto      
       textSetFontActive(1); 
       sizey = textGetHeight();
       sizex = textGetWidth("NEOFAR")+8;

       // y lo enviamos al borde derecho de la pantalla
       textSetColor(GS_BLACK); textPrintXY(320-sizex,240-sizey,"NEOFAR");
       textSetColor(GS_WHITE); textPrintXY(320-sizex-4,240-sizey-4,"NEOFAR");

       gfxRender();       // enviamos todo el flujo al GS
        #ifdef MAKESCREENSHOT
        if (tick++ == 1)
           {
           printf("Taking Screenshot\n");
           ps2_screenshot_file( "host:../screenshots/10_PrintText2.tga", 0, 640, 480, LIB_GS_PSMZ32 );
           printf("Ok. screenshot taken\n");
           }
        #endif

       }

    return 0;
    }
