#include <linux/ps2/gs.h>
#include "gif.h"

QWdata gsPacket[16 * 1024]; // scratch pad emulator 
u_int gsPacketCount = 1;

__inline__ void addPRIM(u_char prim, u_char iip, u_char tme, u_char fge, u_char abe, u_char aa1, u_char fst, u_char ctxt, u_char fix)
    {
    gsPacket[gsPacketCount].u64[0]= PS2_GS_SETREG_PRIM(prim, iip, tme, fge, abe, aa1, fst, ctxt, fix);
    gsPacket[gsPacketCount++].u64[1]= PS2_GS_PRIM;
    }

__inline__ void addRGBAQ(u_char r, u_char g, u_char b, u_char a, float q)
    {
    gsPacket[gsPacketCount].u64[0]= PS2_GS_SETREG_RGBAQ(r, g, b, a, q);
    gsPacket[gsPacketCount++].u64[1]= PS2_GS_RGBAQ;
    }

__inline__ void addXYZ2(u_short x1, u_short y1, u_int z1)
    {
    gsPacket[gsPacketCount].u64[0]= PS2_GS_SETREG_XYZ(x1<<4, y1<<4, z1);
    gsPacket[gsPacketCount++].u64[1]= PS2_GS_XYZF2;
    }

__inline__ void addST(float s, float t)
    {
    gsPacket[gsPacketCount].u64[0]= PS2_GS_SETREG_ST(s, t);
    gsPacket[gsPacketCount++].u64[1]= PS2_GS_ST;
    }
    
__inline__ void add_PK_RGBA(u_char r, u_char g, u_char b, u_char a)
    {
    gsPacket[gsPacketCount].u32[0]= r;
    gsPacket[gsPacketCount].u32[1]= g;
    gsPacket[gsPacketCount].u32[2]= b;
    gsPacket[gsPacketCount++].u32[3]= a;
    }

__inline__ void add_PK_XYZ2(u_short x1, u_short y1, u_int z1)
    {
    gsPacket[gsPacketCount].u32[0]= x1<<4;
    gsPacket[gsPacketCount].u32[1]= y1<<4;
    gsPacket[gsPacketCount].u32[2]= z1;
    gsPacket[gsPacketCount++].u32[3]= 1;
    }
