/***************************************************************
/  Unofficial LlibPlanar - Versin 0.9.1                       /
/                                                              /
/  Modificado por Ifcaro <taslokooo@gmail.com>                 /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Versin original:                                           /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/


#include <llibPlanar.h>


llibtex_Info texInfo;

int ntexturas;

// calcula los qwords que mide una textura
int libGsTextureQWordSize(short w, short h, short dpsm) 
    {
    short bdpsm;
    int size=0;
    bdpsm=dpsm&7;
    switch(bdpsm)
        {
        case 0: size=(w*h  )>>2; break; // 32 bits
        case 1: size=(w*h*3)>>4; break; // 24 bits
        case 2: size=(w*h  )>>3; break; // 16 bits
        case 3: size=(w*h  )>>4; break; // 8 bits
        case 4: size=(w*h  )>>5;        // 4 bits
        }
    return size;
    }

// soporta hasta un poquitin mas de 512x512*32bpp
// la anterior soportaba hasta 256*256*32bpp (mas un poquito)
// si funciona sera adaptada para subir 2048*2048*bpp que
// es el maximo que se puede en una ps2 con 4MB de VRAM
// lo que seria una locura :S
int libGsExecLoadImage2(libGsLoadImage *loadImage, u_long128 *ptr) 
    {
    static u_long128 ExecLoadImagePacket128[20] = {
        0x00000000000000000000000010000006L, // 00-03 DMA CNT QWC=6
        0x00000000000000000000000000000000L, // 08-11 DMA REF QWC=0x4000
        0x00000000000000000000000000000000L, // 08-11 DMA REF QWC=0x4000
        0x00000000000000000000000000000000L, // 08-11 DMA REF QWC=0x4000
        0x00000000000000000000000000000000L, // 08-11 DMA REF QWC=0x4000
        0x00000000000000000000000000000000L, // 08-11 DMA REF QWC=0x4000
        //|       |       |       |
        0x00000000000000000800000000004000L, // 04-07 GIF FLG=IMAGE
        0x00000000000000000000000030004000L, // 08-11 DMA REF QWC=0x4000
        //|       |       |       |
        0x00000000000000000000000010000001L, // 00-03 DMA CNT QWC=1
        0x00000000000000000800000000004000L, // 04-07 GIF FLG=IMAGE
        0x00000000000000000000000030004000L, // 08-11 DMA REF QWC=0x4000
        //|       |       |       |
        0x00000000000000000000000010000001L, // 00-03 DMA CNT QWC=1
        0x00000000000000000800000000004000L, // 04-07 GIF FLG=IMAGE
        0x00000000000000000000000030004000L, // 08-11 DMA REF QWC=0x4000
        //|       |       |       |
        0x00000000000000000000000010000001L, // 00-03 DMA CNT QWC=1
        0x00000000000000000800000000004000L, // 04-07 GIF FLG=IMAGE
        0x00000000000000000000000030004000L, // 08-11 DMA REF QWC=0x4000
        //|       |       |       |
        0x00000000000000000000000010000001L, // 00-03 DMA CNT QWC=1
        0x00000000000000000800000000004000L, // 04-07 GIF FLG=IMAGE
        0x00000000000000000000000030004000L, // 08-11 DMA REF QWC=0x4000
    };

    int count;
    u_int size;
    u_int index;

    u_int *ExecLoadImagePacket=(u_int *)ExecLoadImagePacket128;

    size=libGsTextureQWordSize(loadImage->trxreg.RRW, loadImage->trxreg.RRH, loadImage->bitbltbuf.DPSM);

    if(size>0x100000) 
        {
        LIBOUT("libGsExecLoadImage: texture size bigger than VRAM :p\n");
        return -2;
        }

    count=TIMEOUT;
    while(*D2_CHCR&0x100) 
        {
        if(count--==0) {
            LIBOUT("libGsExecLoadImage: DMA Ch.2 does not terminate\n");
            return -1;
        }
    };

    *((u_long128 *)ExecLoadImagePacket+1)=*((u_long128 *)loadImage);
    *((u_long128 *)ExecLoadImagePacket+2)=*((u_long128 *)loadImage+1);
    *((u_long128 *)ExecLoadImagePacket+3)=*((u_long128 *)loadImage+2);
    *((u_long128 *)ExecLoadImagePacket+4)=*((u_long128 *)loadImage+3);
    *((u_long128 *)ExecLoadImagePacket+5)=*((u_long128 *)loadImage+4);

    ExecLoadImagePacket[(12*0+9)+20]=(u_int)ptr;
    ExecLoadImagePacket[(12*1+9)+20]=(u_int)ptr+0x04000*16;
    ExecLoadImagePacket[(12*2+9)+20]=(u_int)ptr+0x08000*16;
    ExecLoadImagePacket[(12*3+9)+20]=(u_int)ptr+0x0C000*16;
    ExecLoadImagePacket[(12*4+9)+20]=(u_int)ptr+0x10000*16;

    index=((size-1)>>14); // (>>14)==(/0x4000)

    ExecLoadImagePacket[(12*index+4)+20]=(size-0x4000*index)|0x8000;
    ExecLoadImagePacket[(12*index+8)+20]=(size-0x4000*index);

    asm("nop"); //PCSX2 BUG??
    FlushCache(0);

    *D2_QWC=0;
    *D2_TADR=(u_int)&ExecLoadImagePacket[0];
    *D2_CHCR=0x105;

    return 0;
}


/*
    Metodos internos
*/
int imageUse(libGsTexEnv *base, int n,int frame);
int imageFindNextFree();
int textureFindNextFree();
int findBase2(int n);
int getBytesPerPixel(int zpsm);
void textureClearUsed();


/* 
 * Esta funcion ser en un futuro implementada dentro de lalib, la usamos
 * para saber cuanta memoria estamos usando con la pantalla, entre modo grafico
 * y numero de planos. A partir de esa direccion es donde vamos a meter
 * las texturas que carguemos.
 *
 */ 
void setVideoBaseDir(int w,int h,int ztest,int psm)
    {
    // resolucionX * resoslucionY * BytesPerPixel
    texInfo.videoDir_Base = w * h * getBytesPerPixel(psm);

    // si estamos trabajando con un BufferZ
    switch(ztest)
        {
        case LIB_TEST_ZNONE    : texInfo.videoDir_Base *= 2; break; 
        case LIB_TEST_ZALWAYS  : texInfo.videoDir_Base *= 3; break; 
        case LIB_TEST_ZGEQUAL  : texInfo.videoDir_Base *= 3; break; 
        case LIB_TEST_ZGREATER : texInfo.videoDir_Base *= 3; break; 
        }

    texInfo.videoDir_Base    = texInfo.videoDir_Base / 256;
    texInfo.videoDir_Pointer = texInfo.videoDir_Base;
    
    printf("[llibtex] videoDir_Base    = %d \n",(int)texInfo.videoDir_Base);
    printf("[llibtex] videoDir_Pointer = %d \n",(int)texInfo.videoDir_Pointer);
    }

void textureFixDir()
    {
    // marcamos las Imagenes y texturas que tenemos leidas
    // para que no sean liberadas
    texInfo.fixedNumImages   = imageFindNextFree();
    texInfo.fixedNumTextures = textureFindNextFree();

    // marcamos tambien la direccion Base para que el reset
    // lo respete
    texInfo.videoDir_Base = texInfo.videoDir_Pointer;
    }
	
int GetTextureDir(){
	return texInfo.videoDir_Pointer;
}

void SetTextureDir(int dir){
	texInfo.videoDir_Pointer = dir;
}

void textureReset()
    {
    texInfo.videoDir_Pointer = texInfo.videoDir_Base;    
    textureClearUsed();
    }

/*
 * Mediante esta funcion vamos a preparar los arrays para las imagenes
 * y para las texturas que tenemos que leer.
 * Esto es muy poco libre ya que desde el principio tenemos que saber los 
 * recursos que leemos
 */

void texturePrepareArray(int numImages, int numTextures)
    {
    texInfo.fixedNumImages   = 0;
    texInfo.fixedNumTextures = 0; 

    // preparamos el array para las Images
    texInfo.numImages = numImages;
    texInfo.listImages = malloc(texInfo.numImages * sizeof(llibtex_Image));

    // preparamos el array para las textures
    texInfo.numTextures = numTextures;
    texInfo.listTextures =malloc(texInfo.numTextures * sizeof(llibtex_Texture));

    textureClearUsed();
    }

void textureClearUsed()
    {
    int i;

    // inicializamos el array de Imagenes
    for(i=texInfo.fixedNumImages;i<texInfo.numImages;i++) 
        texInfo.listImages[i].used = 0;

    // y lo mismo con las Textures
    for(i=texInfo.fixedNumTextures;i<texInfo.numTextures;i++) 
        texInfo.listTextures[i].used = 0;
    }

/*
 *  este metodo devuelve la proxima Imagen libre dentro del array
 */
int imageFindNextFree()
    {
    int i;
    
    for(i=0;i<texInfo.numImages;i++)
        if (texInfo.listImages[i].used == 0) return i;

    return -1;
    }

/*
 *  este metodo devuelve la proxima Textura Libre dentro del array
 */
int textureFindNextFree()
    {
    int i;
    
    for(i=0;i<texInfo.numTextures;i++)
        if (texInfo.listTextures[i].used == 0) return i;

    return -1;
    }

/*
 * Enviamos una imagen a la memoria del EE
 */
void GSLoadImage(int n)
    {
    libGsLoadImage tp;
    libGsSetDefLoadImage(&tp,
                     texInfo.listImages[n].tbp0,
                     texInfo.listImages[n].tbw,
                     texInfo.listImages[n].psm,
                     0, 0,
                     texInfo.listImages[n].sizeX,
                     texInfo.listImages[n].sizeY) ;
    FlushCache(0);
    libGsExecLoadImage2(&tp, (u_long128 *)texInfo.listImages[n].data);
    libGsSyncPath(0, 0);
    }

void uploadImage(int n,unsigned char* data,int w,int h,int psm,int cbp,int cpsm)
    {
    printf("uploadImage(%d,*,%d,%d,%d,cbp=%d,cpsm=%d) \n",n,w,h,psm,cbp,cpsm);

    // en primer lugar marcamos que estamos usando esta textura
    texInfo.listImages[n].used  = 1;
    texInfo.listImages[n].sizeX = w;
    texInfo.listImages[n].sizeY = h;

    // preparamos la estructura
    texInfo.listImages[n].flush  = 0;
    texInfo.listImages[n].tbp0   = (int)texInfo.videoDir_Pointer;
    texInfo.listImages[n].tbw    = (w>63?w/64:1);
    texInfo.listImages[n].psm    = psm;
    texInfo.listImages[n].w      = findBase2(w);
    texInfo.listImages[n].h      = findBase2(h);
    //TCC
    texInfo.listImages[n].tfx    = LIB_TFX_MODULATE;
    texInfo.listImages[n].cbp    = cbp;
    texInfo.listImages[n].cpsm   = cpsm;
    //CSM
    //CSA
    texInfo.listImages[n].cld    = 1;
    texInfo.listImages[n].filter = LIB_FLT_NEAREST;

    texInfo.listImages[n].data = data; // <- aqui va toda la imagen
    texInfo.listImages[n].gif = 0;     // GIF animated false
    texInfo.listImages[n].clutId = -1; // no tiene clut
    texInfo.listImages[n].currentFrame = 0; // Frame 0
    
    // y la enviamos a la memoria de video
    GSLoadImage(n);

    // desplazamos el puntero para meter la proxima textura detrs
    texInfo.videoDir_Pointer += ((w * h * getBytesPerPixel(psm)) / 256);
    }


int imageLoadRaw(char *filename,int w,int h,int psm)
    {
    unsigned char *data;
    int n = imageFindNextFree();

    if(n==-1)
        printf("[llibtex] Error, sin espacio libre");
    else
        {
        data = RAW_ReadFile(filename);
        uploadImage(n,data,w,h,psm,0,0);
        free(data);
        }
    return n;
    }

int imageLoadRawC(char *filename,int w,int h,int psm)
    {
    unsigned char *data;
    int n = imageFindNextFree();

    if(n==-1)
        printf("[llibtex] Error, sin espacio libre");
    else
        {
        data = filename;//RAW_ReadFile(filename);
        uploadImage(n,data,w,h,psm,0,0);
        free(data);
        }
    return n;
    }
	
int imageLoadIIF(char *filename)
    {
    int psm=0;
    int clutw=0,cluth=0;
    int cbp=0, cpsm=0;
    IIF_HEADER *iif_file;
    unsigned char *dataClut = NULL;
    unsigned char *dataPixels = NULL;
    int n=0,pn=-1;
    int clutid=-1;

    iif_file = IIF_OpenFile(filename);  // <-- Abrimos el archivo IIF

    // Ahora miramos que tipo de imagen es
    //
    // Aqui es donde tenemos que poner la compatibilidad de los defines
    // entre IIF y lalib y donde miramos cuantas imagenes tenemos que
    // subir al GS, y establecer las variables del CLUT, para saber luego
    // si subimos 2 imagens al GS o solamente 1
    //
   	switch(iif_file->psm)
   		{
   		// Basic Types
   		case IIF_RGBA32:       psm=LIB_GS_PSMCT32; clutw=0;  cluth=0;  cpsm=0;              break;
   		case IIF_RGB24:        psm=LIB_GS_PSMCT24; clutw=0;  cluth=0;  cpsm=0;              break;
   		case IIF_RGBA16:       psm=LIB_GS_PSMCT16; clutw=0;  cluth=0;  cpsm=0;              break;

   		// CLUTS (cms1)
   		case IIF_CLUT8_RGBA32: psm=LIB_GS_PSMT8;   clutw=16; cluth=16; cpsm=LIB_GS_PSMCT32; break;
   		case IIF_CLUT8_RGBA16: psm=LIB_GS_PSMT8;   clutw=16; cluth=16; cpsm=LIB_GS_PSMCT16; break;
   		case IIF_CLUT4_RGBA32: psm=LIB_GS_PSMT4;   clutw=8;  cluth=16; cpsm=LIB_GS_PSMCT32; break;
   		case IIF_CLUT4_RGBA16: psm=LIB_GS_PSMT4;   clutw=8;  cluth=16; cpsm=LIB_GS_PSMCT16; break;

   		// Gif animated
   		case IIF_GIF256 :      psm=LIB_GS_PSMT8;   clutw=16; cluth=16; cpsm=LIB_GS_PSMCT32; break;
   		case IIF_GIF16  :      psm=LIB_GS_PSMT4;   clutw=8;  cluth=16; cpsm=LIB_GS_PSMCT32; break;
        }

    // mientras no se demuestre lo contrario
    // la imagen no usara direccion a un clut
    cbp=0;

    //
    // SEND CLUT
    //
    if(clutw>0)
    	{
        clutid = imageFindNextFree();
        dataClut = IIF_readClut(iif_file);  			// <-- Cargamos el CLUT
        uploadImage(clutid,dataClut,clutw,cluth,cpsm,0,0);
        // free(dataClut);

     	// una vez que hemos subido el CLUT al GS miramos
    	// la direccion donde ha caido, ya que luego la data
    	// debe apuntar a esta direccion
    	cbp = texInfo.listImages[clutid].tbp0;
    	}

    //
    // SEND IMAGE
    //
    // si no es un clut tanto cbp como cpsm van a valer 0
    // en caso de ser un clut, ya lo habremos enviado antes
    // y cbp apunta a la direccion de ese clut
    //

    // miramos cuantos Frames tiene el archivo para leer
    int frames = IIF_countFrames(iif_file);
    if(frames == 1)
        {
        n = imageFindNextFree();

        dataPixels = IIF_readImage(iif_file);
        uploadImage(n,dataPixels, iif_file->width, iif_file->height, psm,cbp,cpsm);
        // free(dataPixels);

        pn = n; // pn es el indice que vamos a devolver
        }
    else
        {
        int i;
        // printf("Frames = %d \n", frames);
    	for(i=0;i<frames;i++)
    	    {
            n = imageFindNextFree();
            if(i==0) pn = n; // me guardo el indice del primer fotograma

            dataPixels = IIF_readImage(iif_file); 
            uploadImage(n,dataPixels,iif_file->width,iif_file->height,psm,cbp,cpsm);
            free(dataPixels);
            }

        texInfo.listImages[pn].gif      = 1;
        texInfo.listImages[pn].frames   = frames;
        texInfo.listImages[pn].frametbw = (iif_file->width * iif_file->height) / 256;
        }
    IIF_CloseFile();
    
    texInfo.listImages[pn].clutId = clutid ;
    // printf("IIF -> id = %d clut(%d)\n", pn, clutid);
    return pn;
    }

int imageLoadIIFC(char *filename, int size)
    {
    int psm=0;
    int clutw=0,cluth=0;
    int cbp=0, cpsm=0;
    IIF_HEADER *iif_file;
    unsigned char *dataClut = NULL;
    unsigned char *dataPixels = NULL;
    int n=0,pn=-1;
    int clutid=-1;
    iif_file = IIF_vOpenFile(filename, size);  // <-- Abrimos el archivo IIF

    // Ahora miramos que tipo de imagen es
    //
    // Aqui es donde tenemos que poner la compatibilidad de los defines
    // entre IIF y lalib y donde miramos cuantas imagenes tenemos que
    // subir al GS, y establecer las variables del CLUT, para saber luego
    // si subimos 2 imagens al GS o solamente 1
    //
   	switch(iif_file->psm)
   		{
   		// Basic Types
   		case IIF_RGBA32:       psm=LIB_GS_PSMCT32; clutw=0;  cluth=0;  cpsm=0;              break;
   		case IIF_RGB24:        psm=LIB_GS_PSMCT24; clutw=0;  cluth=0;  cpsm=0;              break;
   		case IIF_RGBA16:       psm=LIB_GS_PSMCT16; clutw=0;  cluth=0;  cpsm=0;              break;

   		// CLUTS (cms1)
   		case IIF_CLUT8_RGBA32: psm=LIB_GS_PSMT8;   clutw=16; cluth=16; cpsm=LIB_GS_PSMCT32; break;
   		case IIF_CLUT8_RGBA16: psm=LIB_GS_PSMT8;   clutw=16; cluth=16; cpsm=LIB_GS_PSMCT16; break;
   		case IIF_CLUT4_RGBA32: psm=LIB_GS_PSMT4;   clutw=8;  cluth=16; cpsm=LIB_GS_PSMCT32; break;
   		case IIF_CLUT4_RGBA16: psm=LIB_GS_PSMT4;   clutw=8;  cluth=16; cpsm=LIB_GS_PSMCT16; break;

   		// Gif animated
   		case IIF_GIF256 :      psm=LIB_GS_PSMT8;   clutw=16; cluth=16; cpsm=LIB_GS_PSMCT32; break;
   		case IIF_GIF16  :      psm=LIB_GS_PSMT4;   clutw=8;  cluth=16; cpsm=LIB_GS_PSMCT32; break;
        }

    // mientras no se demuestre lo contrario
    // la imagen no usara direccion a un clut
    cbp=0;

    //
    // SEND CLUT
    //
    if(clutw>0)
    	{
        clutid = imageFindNextFree();
        dataClut = IIF_vreadClut(iif_file);  			// <-- Cargamos el CLUT
        uploadImage(clutid,dataClut,clutw,cluth,cpsm,0,0);
        // free(dataClut);

     	// una vez que hemos subido el CLUT al GS miramos
    	// la direccion donde ha caido, ya que luego la data
    	// debe apuntar a esta direccion
    	cbp = texInfo.listImages[clutid].tbp0;
    	}

    //
    // SEND IMAGE
    //
    // si no es un clut tanto cbp como cpsm van a valer 0
    // en caso de ser un clut, ya lo habremos enviado antes
    // y cbp apunta a la direccion de ese clut
    //

    // miramos cuantos Frames tiene el archivo para leer
    int frames = IIF_vcountFrames(iif_file);
    if(frames == 1)
        {
        n = imageFindNextFree();

        dataPixels = IIF_vreadImage(iif_file);
        uploadImage(n,dataPixels, iif_file->width, iif_file->height, psm,cbp,cpsm);
        // free(dataPixels);

        pn = n; // pn es el indice que vamos a devolver
        }
    else
        {
        int i;
        // printf("Frames = %d \n", frames);
    	for(i=0;i<frames;i++)
    	    {
            n = imageFindNextFree();
            if(i==0) pn = n; // me guardo el indice del primer fotograma

            dataPixels = IIF_vreadImage(iif_file); 
            uploadImage(n,dataPixels,iif_file->width,iif_file->height,psm,cbp,cpsm);
            free(dataPixels);
            }

        texInfo.listImages[pn].gif      = 1;
        texInfo.listImages[pn].frames   = frames;
        texInfo.listImages[pn].frametbw = (iif_file->width * iif_file->height) / 256;
        }
    IIF_vCloseFile();
    
    texInfo.listImages[pn].clutId = clutid ;
    // printf("IIF -> id = %d clut(%d)\n", pn, clutid);
    return pn;
    }
	
	
// Devolvemos el puntero a los pixels
unsigned char *imageGetPixels(int id)
    {
    return texInfo.listImages[id].data;
    }

// Devolvemos el puntero a la paleta (en caso de tener)
unsigned char *imageGetClut(int id)
    {
    int clutid = texInfo.listImages[id].clutId;
    if(clutid == -1) return 0;
    
    return texInfo.listImages[clutid].data;
    }

// Updateamos el Clut al EE
void imageUpdateClut(int id)
    {
    int clutid = texInfo.listImages[id].clutId;
    if(clutid == -1) return;
    
    GSLoadImage(clutid);
    }
    
int imageLoadBuffer(void* file_ptr,int w,int h,int psm)
    {
    return -1;
    }
    
int imageLoadTGA(char *filename)
    {
    return -1;
    }

int imageGetWidth(int nImage){
	if (nImage>=0 && nImage<=texInfo.numImages){
        return texInfo.listImages[nImage].sizeX;
    }
	return 0;
}

int imageGetHeight(int nImage){
	if (nImage>=0 && nImage<=texInfo.numImages){
        return texInfo.listImages[nImage].sizeY;
    }
	return 0;
}
    
void imageSetTfx(unsigned int nImage,int tfx)
    {
    if (nImage>=0 && nImage<=texInfo.numImages)
        {
        texInfo.listImages[nImage].tfx = tfx;
        }
    }
    
void imageSetFilter(unsigned int nImage,int filter)
    {
    if (nImage>=0 && nImage<=texInfo.numImages)
        {
        texInfo.listImages[nImage].filter = filter;
        }
    }    
    


int textureCreate(
                    unsigned int nImage,  // Imagen sobre la que recortamos la textura 
                    int x1,int y1,        //
                    int x2,int y2         //
                    )        
    {
    float S1,T1,S2,T2;
    int ImageSizeX, ImageSizeY;

    ImageSizeX = texInfo.listImages[nImage].sizeX; // Resolucion X en pixels
    ImageSizeY = texInfo.listImages[nImage].sizeY; // Resolucion Y en pixels

    S1 = ((float)x1) / ((float)ImageSizeX); 
    T1 = ((float)y1) / ((float)ImageSizeY);
    S2 = ((float)x2) / ((float)ImageSizeX);
    T2 = ((float)y2) / ((float)ImageSizeY);

    return textureCreateST(nImage,S1,T1,S2,T2);
    }

int textureCreateST(
                    unsigned int nImage,  // Imagen sobre la que recortamos la textura 
                    float S1,float T1,    //
                    float S2,float T2     //
                    )        
    {
    int n;
    
    // antes que nada, ordenamos las xy para que este en el orden apropiado
    float temp;
    if (S2<S1) { temp=S1; S1=S2; S2=temp; }
    if (T2<T1) { temp=T1; T1=T2; T2=temp; }
    
    // buscamos el proximo hueco libre
    n = textureFindNextFree();
    
    if(n==-1)
        printf("[llibtex] Error, sin espacio libre");
    else
        {
        // la marcamos como que la estamos usando
        texInfo.listTextures[n].used= 1;

        // le especificamos sobre que textura es este copy
        texInfo.listTextures[n].ImageIndex = nImage;

        // y las 4 corrdenadas XY para acceder rapido a las esquinas    
        texInfo.listTextures[n].S[0] = S1; texInfo.listTextures[n].S[1] = S2;
        texInfo.listTextures[n].S[2] = S1; texInfo.listTextures[n].S[3] = S2;
        texInfo.listTextures[n].T[0] = T1; texInfo.listTextures[n].T[1] = T1;
        texInfo.listTextures[n].T[2] = T2; texInfo.listTextures[n].T[3] = T2;
        }

    return n;
    }

llibtex_Texture textureGetBox(int n)
    {
    return texInfo.listTextures[n];
    }    


int imageUse(libGsTexEnv *base, int n, int frame)
    {
    int tags=0;

    if (n>=0 && n<=texInfo.numImages)
        {
        llibtex_Image *image = &texInfo.listImages[n];
        short tbp0 = image->tbp0;
        
        // Aqui es donde metemos el tbp0 que nos interesa cuando
        // estamos trabajando con alguna textura animada
        // textureSetFrame(sprite.frame); // frame que nos interesa
        // textureUse(sprite.texture);

        // -> tbp0
        // unsigned char gif; // GIF animated -> 1 | 0
        // short frames;      // number of frames
        // short frametbw;    // size of frame in tbw
        if (image->gif)
            {
            // printf("image->frames = %d \n", image->frames);
            // printf("frame = %d \n", frame);

            int frameActual =  frame % image->frames;
            tbp0 += frameActual * image->frametbw;
            }

        tags = libGsSetDefTexEnv(
                base,
                image->flush,
                tbp0,
                image->tbw,
                image->psm,
                image->w,
                image->h,
                image->tfx,
                image->cbp,
                image->cpsm,
                image->cld,
                image->filter);
        }
    else
        {
        // errores para capturar
        //printf("[ERROR] - imageUse(%d) = Out of Range\n",n);
        }
    return tags;
    }

void textureUseFrame(int n,int frame)
    {
    int idImagen = texInfo.listTextures[n].ImageIndex;

    if(frame==-1)
        frame = texInfo.listImages[idImagen].currentFrame;

//    if (texInfo.textureActive != n)
//        {
        // activamos la Imagen que queremos usar

    gsPacketCount += imageUse(
            (libGsTexEnv *)&gsPacket[gsPacketCount],
            idImagen,
            frame);

    texInfo.textureActive = n;
//        }
    }

void imageResetFrame(int n)
    {
    texInfo.listImages[n].currentFrame = 0; 
    }
    
void imageSetFrame(int n,int frame)
    {
    texInfo.listImages[n].currentFrame = frame;
    }

void imageFree(int n)
    {
		if(n>=0 && n<=texInfo.numImages){
	    texInfo.listImages[n].used = 0;
		texInfo.listImages[texInfo.listImages[n].clutId].used = 0;
		texInfo.listTextures[n].used = 0;
		}
    }
	
void textureUse(int n)
    {
    int idImagen = texInfo.listTextures[n].ImageIndex;
    textureUseFrame(n, texInfo.listImages[idImagen].currentFrame);
    }

int findBase2(int n)
    {
    switch(n)
        {
        case 1: return 0;
        case 2: return 1;
        case 4: return 2;
        case 8: return 3;
        case 16: return 4;
        case 32: return 5;
        case 64: return 6;
        case 128: return 7;
        case 256: return 8;
        case 512: return 9;
       }
    return 1;
    }

int getBytesPerPixel(int psm)
    {
    switch(psm)
        {
        case LIB_GS_PSMT8  : return 1; break;
        case LIB_GS_PSMCT16: return 2; break;
        case LIB_GS_PSMCT24: return 3; break;
        case LIB_GS_PSMCT32: return 4; break;
        }
    return 4;
    }

