/***************************************************************
/  Unofficial LlibPlanar - Versin 0.9.1                       /
/                                                              /
/  Modificado por Ifcaro <taslokooo@gmail.com>                 /
/  http://ps2dev.ifcaro.net                                    /
/                                                              /
/  Versin original:                                           /
/  Angel Garbayo Dominguez (neofar@ofcode.com)                 /
/  http://ps2dev.ofcode.com                                    /
/                                                              /
/  last mod: 20-11-2008                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

// #include <fileio.h>		// IO file functions
// #include <stdio.h>		// sprintf 

#include <llibplanar.h>
#include <string.h>
#include <ctype.h>
#include <debug.h>
#include <loadfile.h>
#include "mass_rpc.h"
#include <iopcontrol.h>
#include <iopheap.h>
#include <sifrpc.h>

extern u8 *freesio2_irx;
extern int size_freesio2_irx;

extern u8 *usbd_irx;
extern int size_usbd_irx;

extern u8 *usb_mass_irx;
extern int size_usb_mass_irx;

void Reset();
char* findelfpath(char *path);
char* substr(char* cadena, int comienzo, int longitud);

int mediaMode = MODE_HOST;
char* modomassymemory;

char *vFile;
int vPointer;
int vSize;

int reseteado=0;
int usbloaded=0;

char* minusculas(char* texto){
int i;
	for(i = 0; texto[i]; i++){
		texto[i] = tolower(texto[i]); 
	}
	return texto;
}
char* substr(char* cadena, int comienzo, int longitud)
{
	if (longitud == 0) longitud = strlen(cadena)-comienzo-1;
	
	char *nuevo = (char*)malloc(sizeof(char) * longitud);
	
	strncpy(nuevo, cadena + comienzo, longitud);
	
	nuevo[longitud]=0;
		
	return nuevo;
}

char* barrasunix(char* texto){
int i;
	for(i = 0; texto[i]; i++){
		if (texto[i]==92){ texto[i]=47;}
	}
	return texto;
}

char* barrasdos(char* texto){
int i;
	for(i = 0; texto[i]; i++){
		if (texto[i]==47){ texto[i]=92;}
	}
	return texto;
}

char* findelfpath(char *texto){
int i;
int e=0;
int u=0;
char* ret=(char*)malloc(sizeof(char) * strlen(texto));
sprintf(ret,"%c",(int)NULL);
	for(i = 0; texto[i]; i++){
		if (texto[i]==58){
			i++;
			if (texto[e]==92 || texto[e]==47){ i++;}
			for(e = i; texto[e]; e++){
				if (texto[e]==92 || texto[e]==47){ u=e;}
			}
			for(e = i; e<u; e++){
				sprintf(ret,"%s%c",ret,texto[e]);
			}
				return ret;
		} 
	}
	return "";
}

void loadusb(){
init_scr();
int ret=-1;
	if(usbloaded==0){
	if (reseteado==0)Reset();
		SifInitRpc(0);  
		//ret = SifLoadModule(USBD_IRX, 0, NULL);
		ret=SifExecModuleBuffer(&usbd_irx, size_usbd_irx, 0, NULL,  NULL);
		if (ret < 0) {
			printf("sifLoadModule %s failed: %d\n", "usbd", ret);
			//while(1);
		} else printf("usbd.irx ok  ret=%i\n", ret );

		if(ret>=0){
			//ret = SifLoadModule(USB_MASS_IRX, 0, NULL);    
			ret=SifExecModuleBuffer(&usb_mass_irx, size_usb_mass_irx, 0, NULL, NULL);
			if (ret < 0) {
				printf("sifLoadModule %s failed: %d\n", "usb_mass", ret);
				while(1);
			} else {
				printf("usb_mass.irx ok. ret=%i \n", ret);
			}

			while(usb_mass_bindRpc()<0);
			usbloaded=1;
			//ret = usb_mass_bindRpc();
			/*if (ret < 0 ) {
				printf("\nSifBindRpc failed: %d !!!!\n", ret);
			}else {
				printf("ok\n");
			}*/
		}
	}
}

/*
* Find the mediaMode
*
* archivo1 es el archivo a buscar en cd o host
* archivo2 es el archivo a buscar en usb o memory card
*/
void findMediaMode(char* archivo1){
int ret;

	//init_scr();
	modomassymemory=findelfpath(archivo1);

	if(!strncmp(minusculas(archivo1), "host", 4)){
		printf("Detectado HOST:\n");
		setMediaMode(MODE_HOST);
	}else if(!strncmp(minusculas(archivo1), "mc0", 3)){
		printf("Detectado MEMORY CARD 1:\n");
		if (reseteado==0)Reset();
		SifInitRpc(0);  
			//SifLoadModule("rom0:SIO2MAN", 0, NULL);
			delay(1);
			ret=SifExecModuleBuffer(&freesio2_irx, size_freesio2_irx, 0, NULL,  NULL);
			if (ret < 0) {
			printf("sifLoadModule %s failed: %d\n", "freesio2", ret);
			while(1);
			} else printf("freesio2.irx ok  ret=%i\n", ret );
			ret=SifLoadModule("rom0:XMCMAN", 0, NULL);
			if (ret < 0) {
			printf("sifLoadModule %s failed: %d\n", "XMCMAN", ret);
			while(1);
			} else printf("XMCMAN ok  ret=%i\n", ret );
			delay(1);
			ret=SifLoadModule("rom0:XMCSERV", 0, NULL);
			if (ret < 0) {
			printf("sifLoadModule %s failed: %d\n", "XMCSERV", ret);
			while(1);
			} else printf("XMCSERV ok  ret=%i\n", ret );
			delay(1);
		setMediaMode(MODE_MC0);
	}else if(!strncmp(minusculas(archivo1), "mc1", 3)){
		printf("Detectado MEMORY CARD 2:\n");
		if (reseteado==0)Reset();
		SifInitRpc(0);  
			//SifLoadModule("rom0:SIO2MAN", 0, NULL);
			delay(1);
			ret=SifExecModuleBuffer(&freesio2_irx, size_freesio2_irx, 0, NULL,  NULL);
			if (ret < 0) {
			printf("sifLoadModule %s failed: %d\n", "freesio2", ret);
			while(1);
			} else printf("freesio2.irx ok  ret=%i\n", ret );
			ret=SifLoadModule("rom0:XMCMAN", 0, NULL);
			if (ret < 0) {
			printf("sifLoadModule %s failed: %d\n", "XMCMAN", ret);
			while(1);
			} else printf("XMCMAN ok  ret=%i\n", ret );
			delay(1);
			ret=SifLoadModule("rom0:XMCSERV", 0, NULL);
			if (ret < 0) {
			printf("sifLoadModule %s failed: %d\n", "XMCSERV", ret);
			while(1);
			} else printf("XMCSERV ok  ret=%i\n", ret );
			delay(1);
		setMediaMode(MODE_MC1);
	}else if(!strncmp(minusculas(archivo1), "mass", 4)){
		printf("Detectado USB:\n");
		loadusb();
			setMediaMode(MODE_MASS);
	}else if(!strncmp(substr(minusculas(archivo1),1,2), ":\\", 2)){
		printf("Detectado PCSX2: \n");
		setMediaMode(MODE_PCSX2);
	}else{
		printf("Detectado CDROM: %s\n", minusculas(archivo1));
		setMediaMode(MODE_CD);
	}
		
	delay(10);
}
void Reset()
{
	SifIopReset("rom0:UDNL rom0:EELOADCNF",0);
	while(!SifIopSync());
	fioExit();
	SifExitIopHeap();
	SifLoadFileExit();
	SifExitRpc();
	SifExitCmd();

	SifInitRpc(0);
	FlushCache(0);
	FlushCache(2);
	reseteado=1;
}
void delay(int count) {
	int i;
	int ret;
	for (i  = 0; i < count; i++) {
	        ret = 0x01000000;
		while(ret--) asm("nop\nnop\nnop\nnop");
	}
}

/*
 * Sets the MediaMode 
 */
void setMediaMode(int media)
	{
	mediaMode = media;

	// si seleccionan un modo no valido 
	// ponemos un HOST
	if(!(mediaMode>=MODE_HDD && mediaMode<=MODE_MASS)) 
 		mediaMode = MODE_HOST;
	}

/*
 * returns the Media Mode Selected
 */
int getMediaMode(int media)
	{
	return mediaMode;
	}    

/*
 * Returns the 'REAL' name of a file in the selected Media Mode
 *
 * Example:
 *     char fname[FIO_PATH_MAX];
 *     getMediaName(&fname, "file.txt");
 *
 *     now fname = "host:file.txt" or "cdrom:file.txt;1"
 */
void getMediaName(char *fname, char *filename)
	{
	if(strncmp(minusculas(filename), "host:", 5) && strncmp(minusculas(filename), "mc0:", 4) && strncmp(minusculas(filename), "mc1:", 4) && strncmp(minusculas(filename), "mass:", 5) && strncmp(minusculas(filename), "cdrom:", 6)){
		getMediaNameFor(fname, filename, mediaMode);
	}else{
		strcpy(fname,filename);
	}
	}    

/*
 * Return the 'Real' name of a file in the Media Mode
 */

void getMediaNameFor(char *fname, char *filename,int media)
	{
	switch(media)
		{
		// case MODE_HDD : sprintf(fname, "%s:%s"   , "hdd", filename); break;
		case MODE_CD  : sprintf(fname, "%s:\\%s;1" , "cdrom", barrasdos(filename)); break;
		case MODE_MC0 : sprintf(fname, "%s:/%s/%s"   , "mc0", barrasunix(modomassymemory),barrasunix(filename)); break;
		case MODE_MC1 : sprintf(fname, "%s:/%s/%s"   , "mc1", barrasunix(modomassymemory),barrasunix(filename));break;
		case MODE_HOST: sprintf(fname, "%s:%s"   , "host", filename);break;
		case MODE_MASS: sprintf(fname, "%s:\\%s\\%s"   , "mass", barrasdos(modomassymemory),barrasdos(filename));break;
		case MODE_PCSX2: sprintf(fname, "%s" , filename);break;
		}		
	// --- --- ---
	}	

/****************************************************************************
 * Universal file opening function.  Returns the handle to the file.		*
 ****************************************************************************/
int openFile(char *filename, int mode)
	{
	int fd = 0;
    static char fname[FIO_PATH_MAX];   // 256 Chars
    getMediaName(&fname[0], filename); 

	switch(mediaMode)
		{
		// case MODE_HDD : fd = fileXioOpen(fname, mode, 0); break;
		case MODE_CD  : fd = fioOpen(fname, mode); break;
		 case MODE_MC0 : fd = fioOpen(fname, mode); break;
		 case MODE_MC1 : fd = fioOpen(fname, mode); break;
		case MODE_HOST: fd = fioOpen(fname, mode); break;	
		case MODE_MASS: fd = fioOpen(fname, mode); break;
		case MODE_PCSX2: fd = fioOpen(fname, mode); break;
		}

	if(fd<=0)
		{
		printf("Error opening file : %s \n", fname);
		SleepThread();
		}

	return fd;
	}

void vopenFile(char *source, int size){
	//vFile=source;
	vFile=source;//malloc (sizeof(unsigned char*)*size);
	vPointer=(int)vFile;
	//memcpy(vFile,source,size);
	vSize=size;
	printf("VFILE: %c %d\n",source[0], vSize);
}
	
/****************************************************************************
 * Universal file closing function.											*
 ****************************************************************************/
void closeFile(int handle)
	{
	switch(mediaMode)
		{
    	// case MODE_HDD : fileXioClose(handle); break;
    	case MODE_CD  : fioClose(handle); break;
		case MODE_MC0 : fioClose(handle); break;
    	 case MODE_MC1 : fioClose(handle); break;
    	case MODE_HOST: fioClose(handle); break;
    	case MODE_MASS: fioClose(handle); break;
		case MODE_PCSX2: fioClose(handle); break;
    	}
 	}

void vcloseFile(){
	free(vFile);
	vPointer=0;
}
	
/****************************************************************************
 * Universal file reading function.  Returns the amount of bytes read.		*
 ****************************************************************************/
int readFile(int handle, void *buffer, int size)
	{
	int sr =0;
	switch(mediaMode)
		{
		// case MODE_HDD : sr = fileXioRead(handle, buffer, size); break;
		case MODE_CD  : sr = fioRead(handle, buffer, size); break;
		case MODE_MC0 : sr = fioRead(handle, buffer, size); break;
		case MODE_MC1 : sr = fioRead(handle, buffer, size); break;
		case MODE_HOST: sr = fioRead(handle, buffer, size); break;
  		case MODE_MASS: sr = fioRead(handle, buffer, size); break;
		case MODE_PCSX2: sr = fioRead(handle, buffer, size); break;
  		}
	return sr;
	}

char* vreadFile(int size){
	char *ret=malloc (sizeof(char*)*size);
	//int e;
	if(size<=0){ printf("ERROR:"); SleepThread();}
	//ret="";
	//printf("intentando leer %d de %d\n",size,vSize);
	//for(e = vPointer; e<vPointer+size; e++){
		//printf("%c",source[e]);
		//sprintf(ret,"%s%c",ret,source[e]);
	//}
	memcpy(ret,vFile,size);
	//printf("LEIDO: %s\n",ret);
	vFile=vFile+size;
	return ret;
}

/****************************************************************************
 * Universal file reading function.  Returns buffer.	                	*
 ****************************************************************************/
unsigned char *readFileBlock(int handle, int size)
	{
	unsigned char *buffer = memalign(64,size);	    
	int loaded;

	if(buffer==0)
		{
		closeFile(handle);
		printf("Read: Out of memory while loading \n");
		SleepThread();
		}
		
    loaded = readFile(handle, buffer, size);

    if(loaded != size)
    	{
    	closeFile(handle);
    	printf("Read: Error reading file (%d, expected %d)\n",loaded,size);
    	SleepThread();
    	}
    
    return buffer;
    }    
	
char * vreadFileBlock(int size){
	unsigned char *buffer = memalign(64,size);	    
	//int loaded;
	
	//printf("vFILEBLOCK: %d\n",size);
	
	if(buffer==0)
		{
		vcloseFile();
		printf("Read: Out of memory while loading \n");
		SleepThread();
		}
		
    buffer = vreadFile(size);

    /*if(sizeof(buffer) != size)
    	{
    	vcloseFile();
    	printf("Read: Error reading file (%d, expected %d)\n",strlen(buffer),size);
    	SleepThread();
    	}*/
    
    return buffer;
}
	
/****************************************************************************
 * Universal file seek function.											*
 ****************************************************************************/
int seekFile(int handle, int pos, int rel)
	{
	int sr=0;
	switch(mediaMode)
    	{
    	// case MODE_HDD : sr = fileXioLseek(handle, pos, rel); break;
    	case MODE_CD  : sr = fioLseek(handle, pos, rel); break;
    	 case MODE_MC0 : sr = fioLseek(handle, pos, rel); break;
    	 case MODE_MC1 : sr = fioLseek(handle, pos, rel); break;
    	case MODE_HOST: sr = fioLseek(handle, pos, rel); break;
    	case MODE_MASS: sr = fioLseek(handle, pos, rel); break;
		case MODE_PCSX2: sr = fioLseek(handle, pos, rel); break;
    	}
	return sr;
	}
	
int vseekFile(int pos, int rel){
	if(rel==SEEK_SET){
		*vFile=pos;
	}else if(rel==SEEK_CUR){
		vFile=vFile+pos;
	}else if(rel==SEEK_END){
		vFile=vFile+vSize;
	}
	//printf("VSEEK: %d\n",(int)vFile);
	
return (int)vFile;
}
// -------------------



