#include <dos.h>
#include <time.h>
#include <stdio.h>

#include "iif.h"
#include "loadClut.h"


void swapColor(unsigned char *data, int i,int j);

void printMap(unsigned char *data, int n);
void printColor(unsigned char *data, int i);

void orderByLuminance(char *filename)
    {
    long i,j;
    
    // Open File
    clutOpen(filename);
/*
    // el Order solo lo permito para clut8RGBA32
    if(clutGetType()!=IIF_CLUT8_RGBA32 || clutGetType()!=IIF_GIF256)
        {
        printf("Order only works for Clut8RGBA32\n");
        clutClose();
        return;
        }
*/


    // Load Palette
    unsigned char *pal = clutLoadPalette();
    unsigned char map[256];
    unsigned char reverse[256];
    
    for(i=0;i<256;i++)
        map[i]=i;
/*
    printMap(pal,16);

    int p = 5;
    printf("-----------------\n");
    printColor(pal,p);
*/

    // Order By Luminance
    for(i=0  ;i<256;i++)
    for(j=i+1;j<256;j++)
        {
        int lum1 = getLuminance(pal[i*4+0],pal[i*4+1],pal[i*4+2]);
        int lum2 = getLuminance(pal[j*4+0],pal[j*4+1],pal[j*4+2]);

        if(lum2 > lum1)
            {
            swapColor(pal,i,j);
            int t = map[i];
            map[i]= map[j];
            map[j]= t;
            }
        }

    for(i=0;i<256;i++) reverse[map[i]] = i;
    for(i=0;i<256;i++) map[i] = reverse[i];
/*
    printColor(pal,p);
    printf("map[%d] = %d \n",p,map[p]);
    printColor(pal,map[p]);

    printf("-----------------\n");
    printMap(pal,16);

    printf("-----------------\n");
    for(i=0;i<16;i++)
    printf("map[%d] = %d\n",i,map[i]);
    */

    // Return palette to IIF File
    clutUpdatePalette(pal);
    free(pal);
    
    // Get Image Data
    long sizeImage = clutGetSizeImage();
    unsigned char *data = clutLoadImage();    
    
    // Swap colors to assign for the new palette
    for (i=0;i<sizeImage;i++)
        {
        data[i] = map[data[i]];
        }

    // And return Image Data to file
    clutUpdateImage(data);
    free(data);

    // close file ;)
    clutClose();
    }

void printMap(unsigned char *data, int n)
    {
    int i;
    for(i=0;i<n;i++)
        printColor(data, i);
    }

void printColor(unsigned char *data, int i)
    {
    printf("[%3d] %3d %3d %3d \n",i,data[i*4+0],data[i*4+1],data[i*4+2]);
    }

void swapColor(unsigned char *data, int i,int j)
     {
     unsigned char t;

     t           = data[i*4+0];
     data[i*4+0] = data[j*4+0];
     data[j*4+0] = t; // R
     
     t = data[i*4+1]; data[i*4+1] = data[j*4+1]; data[j*4+1] = t; // G
     t = data[i*4+2]; data[i*4+2] = data[j*4+2]; data[j*4+2] = t; // B
     t = data[i*4+3]; data[i*4+3] = data[j*4+3]; data[j*4+3] = t; // A
     }
